Package: R2nparray
Version: 0.1
Date: 2011-08-23
Title: R to Numpy Arrays
Author: Skipper Seabold <jsseabold@gmail.com>
Maintainer: Skipper Seabold <jsseabold@gmail.com>
Description: Writes R matrices, vectors, and scalars to a file as numpy arrays
License: BSD
URL: https://www.github.com/statsmodels/statsmodels
Repository: github
Collate:
    'R2nparray-package.R'
    'R2nparray.R'

What Statsmodels is
===================
What it is
==========

Statsmodels is a Python package that provides a complement to scipy for statistical computations including descriptive statistics and estimation and inference for statistical models.

Main Features
=============

* linear regression models: Generalized least squares (including weighted least squares and
  least squares with autoregressive errors), ordinary least squares.
* glm: Generalized linear models with support for all of the one-parameter
  exponential family distributions.
* discrete: regression with discrete dependent variables, including Logit, Probit, MNLogit, Poisson, based on maximum likelihood estimators
* rlm: Robust linear models with support for several M-estimators.
* tsa: models for time series analysis
  - univariate time series analysis: AR, ARIMA
  - vector autoregressive models, VAR and structural VAR
  - descriptive statistics and process models for time series analysis
* nonparametric : (Univariate) kernel density estimators
* datasets: Datasets to be distributed and used for examples and in testing.
* stats: a wide range of statistical tests
  - diagnostics and specification tests
  - goodness-of-fit and normality tests
  - functions for multiple testing
  - various additional statistical tests
* iolib
  - Tools for reading Stata .dta files into numpy arrays.
  - printing table output to ascii, latex, and html
* miscellaneous models
* sandbox: statsmodels contains a sandbox folder with code in various stages of
  developement and testing which is not considered "production ready".
  This covers among others Mixed (repeated measures) Models, GARCH models, general method
  of moments (GMM) estimators, kernel regression, various extensions to scipy.stats.distributions,
  panel data models, generalized additive models and information theoretic measures.


Where to get it
===============

The master branch on GitHub is the most up to date code

    https://www.github.com/statsmodels/statsmodels

Source download of release tags are available on GitHub

    https://github.com/statsmodels/statsmodels/tags

Binaries and source distributions are available from PyPi

    http://pypi.python.org/pypi/statsmodels/


Installation from sources
=========================

See INSTALL.txt for requirements or see the documentation

    http://statsmodels.sf.net/devel/install.html


License
=======

Modified BSD (3-clause)


Documentation
=============

The official documentation is hosted on SourceForge

    http://statsmodels.sf.net/


Windows Help
============
The source distribution for Windows includes a htmlhelp file (statsmodels.chm).
This can be opened from the python interpreter ::

    >>> import statsmodels.api as sm
    >>> sm.open_help()


Discussion and Development
==========================

Discussions take place on our mailing list. 

    http://groups.google.com/group/pystatsmodels

We are very interested in feedback about usability and suggestions for improvements. 


Bug Reports
===========

Bug reports can be submitted to the issue tracker at

    https://github.com/statsmodels/statsmodels/issues

What the l1 addition is
=======================
A slight modification that allows l1 regularized LikelihoodModel.

Regularization is handled by a fit_regularized method.

Main Files
==========

l1_demo/demo.py
    $ python demo.py --get_l1_slsqp_results logit
    does a quick demo of the regularization using logistic regression.

l1_demo/sklearn_compare.py
    $ python sklearn_compare.py
    Plots a comparison of regularization paths.  Modify the source to use
    different datasets.

statsmodels/base/l1_cvxopt.py
    fit_l1_cvxopt_cp()
        Fit likelihood model using l1 regularization.  Use the CVXOPT package.
    Lots of small functions supporting fit_l1_cvxopt_cp

statsmodels/base/l1_slsqp.py
    fit_l1_slsqp()
        Fit likelihood model using l1 regularization.  Use scipy.optimize
    Lots of small functions supporting fit_l1_slsqp

statsmodels/base/l1_solvers_common.py
    Common methods used by l1 solvers

statsmodels/base/model.py
    Likelihoodmodel.fit()
        3 lines modified to allow for importing and calling of l1 fitting functions

statsmodels/discrete/discrete_model.py
    L1MultinomialResults class
        Child of MultinomialResults
    MultinomialModel.fit()
        3 lines re-directing l1 fit results to the L1MultinomialResults class

# Documentation Documentation

We use a combination of sphinx and Jupyter notebooks for the documentation.
Jupyter notebooks should be used for longer, self-contained examples demonstrating
a topic.
Sphinx is nice because we get the tables of contents and API documentation.

## Build Process

Building the docs requires a few additional dependencies. You can get most
of these with

```bash

   python -m pip install -e .[docs]

```

From the root of the project.
Some of the examples rely on `rpy2` to execute R code from the notebooks.
It's not included in the setup requires since it's known to be difficult to
install.

To generate the HTML docs, run ``make html`` from the ``docs`` directory.
This executes a few distinct builds

1. datasets
2. notebooks
3. sphinx

# Notebook Builds

We're using `nbconvert` to execute the notebooks, and then convert them
to HTML. The conversion is handled by `statsmodels/tools/nbgenerate.py`.
The default python kernel (embedded in the notebook) is `python3`.
You need at least `nbconvert==4.2.0` to specify a non-default kernel,
which can be passed in the Makefile.

This directory holds files that were once part of statsmodels but
are no longer maintained.  They are retained here in order to have their
git histories readily available, but should *not* be considered usable.

=====================================
numpydoc -- Numpy's Sphinx extensions
=====================================

Numpy's documentation uses several custom extensions to Sphinx.  These
are shipped in this ``numpydoc`` package, in case you want to make use
of them in third-party projects.

The following extensions are available:

  - ``numpydoc``: support for the Numpy docstring format in Sphinx, and add
    the code description directives ``np-function``, ``np-cfunction``, etc.
    that support the Numpy docstring syntax.

  - ``numpydoc.traitsdoc``: For gathering documentation about Traits attributes.

  - ``numpydoc.plot_directives``: Adaptation of Matplotlib's ``plot::``
    directive. Note that this implementation may still undergo severe
    changes or eventually be deprecated.

  - ``numpydoc.only_directives``: (DEPRECATED)

  - ``numpydoc.autosummary``: (DEPRECATED) An ``autosummary::`` directive.
    Available in Sphinx 0.6.2 and (to-be) 1.0 as ``sphinx.ext.autosummary``,
    and it the Sphinx 1.0 version is recommended over that included in
    Numpydoc.

This directory is only of interest to developers.  It contains files needed to build the docs automatically and to do code maintenance. The below is just a reminder of the commands to update things. It may not necessarily reflect the current workflow.

How to update the main entry page
---------------------------------

If you want to update the main docs page from the statsmodels-website then
run the following (with your credentials)

make clean
make html
rsync -avPr -e ssh build/html/* jseabold,statsmodels@web.sourceforge.net:htdocs/

How to update the nightly builds
--------------------------------
Note that this is done automatically with the update_web.py script except for
new releases.  They should be done by hand if there are any backported changes.

Important: Make sure you have the version installed for which you are building 
the documentation if done by hand.

To update devel branch (from the master branch)

Make sure you have master installed
cd to docs directory
make clean
make html

rsync -avPr -e ssh build/html/* jseabold,statsmodels@web.sourceforge.net:htdocs/devel

How to add a new directory
---------------------------
If you want to create a new directory on the sourceforge site. This can be done on linux as follows

sftp jseabold,statsmodels@web.sourceforge.net
<enter password>

mkdir 0.2
bye

Then make sure you have the release installed, cd to the docs directory and run

make clean
make html

rsync -avPr -e ssh build/html/* jseabold,statsmodels@web.sourceforge.net:htdocs/0.2

Using without installing
------------------------

To use this script from an R session: 

    source('statsmodels/tools/R2nparray/R/R2nparray.R')

The 3 most useful commands are: cat_items(), convert_items() and
apply_functions(). To print the content of an R regression to file in a format readable in python, you can:

    sink(file='tmp.py')
    data(iris)
    mod = lm(Sepal.Length ~ Sepal.Width, data=iris)
    cat_items(mod)
    sink()

Install the R2nparray package
-----------------------------

To make full use of the package's functions (including reading docs), you can
install R2nparray in your R library. This first requires installing the
devtools and roxygen2 packages: 

    install.packages(c('devtools', 'roxygen2'))

Then, you need to create a directory to host the documentation. The ``man``
directory should be located here: 

    mkdir statsmodels/tools/R2nparray/man

Finally, run ``R`` inside the ``statsmodels.tools.R2nparray`` folder, and execute:

    library(devtools)
    document()
    install()

# Continuous Integration Tools

These scripts are used to implement Continuous Integration on Travis, AppVeyor
and Azure.  They should not be removed without careful consideration of the 
consequences.

This README was copied from
http://projects.scipy.org/scikits/browser/trunk/learn/scikits/learn/datasets/
-----------------------------------------------------------------------------

Last Change: Tue Jul 17 04:00 PM 2007 J

This packages datasets defines a set of packages which contain datasets useful
for demo, examples, etc... This can be seen as an equivalent of the R dataset
package, but for python.

Each subdir is a python package, and should define the function load, returning
the corresponding data. For example, to access datasets data1, you should be able to do:

>> from datasets.data1 import load
>> d = load() # -> d contains the data of the datasets data1

load can do whatever it wants: fetching data from a file (python script, csv
file, etc...), from the internet, etc... Some special variables must be defined
for each package, containing a python string:
    - COPYRIGHT: copyright informations
    - SOURCE: where the data are coming from
    - DESCHOSRT: short description
    - DESCLONG: long description
    - NOTE: some notes on the datasets.

For the datasets to be useful in the learn scikits, which is the project which initiated this datasets package, the data returned by load has to be a dict with the following conventions:
    - 'data': this value should be a record array containing the actual data.
    - 'label': this value should be a rank 1 array of integers, contains the
      label index for each sample, that is label[i] should be the label index
      of data[i].
    - 'class': a record array such as class[i] is the class name. In other
      words, this makes the correspondance label index <> label name.

Binstar
=======

[Binstar](http://binstar.org) is Continuum's solution for binary package distribution.  This directory contains the files required for building a binstar package:
 
 * `meta.yaml` - Information about the package and dependencies
 * `bld.bat` - Windows batch file called in the build process
 * `build.sh` - Linux/OSX batch file called in the build process

Two other helper files are included to automate building across Python 2.7, 3.3 and 3.4.

 * `binstar_windows.bat`
 * `binstar_unix.sh`

Running either file from statsmodels/binstar will build all three versions and upload them, assuming the account has been authenticated using 

```
binstar login
```

Installing from binstar
-----------------------
The most recent snapshot can be installed using 

```
conda install -c https://conda.binstar.org/statsmodels statsmodels
``` 

The format for landing.yml should be self-explanatory. The images should be placed in docs/source/_static/images/. They will be displayed at 360 x 225 (W x H). It's best to save them as a png with a resolution of a multiple of at least 720 x 450. If you want, you can use png crush to make the images smaller.

The code in this folder is based on the Federal Reserve Bank of New York code
found at https://github.com/FRBNY-TimeSeriesAnalysis/Nowcasting, which was
downloaded as of commit 19f365cab8269e3aac3faa11ad091d6e913c5c43. Only the
files from that repository which were required for generating the test results
are included here.

In additionm the following files from the original package have been modified
(use git diff against the above repository to see the changes)

- functions/dfm.m
- functions/update_nowcast.m

The following files are not a part of the original package:

- test_DFM_blocks.m
- test_DFM.m
- test_news_blocks.m
- test_news.m
- test_spec_blocks.xls
- test_spec.xls

# Originally from https://github.com/vincentarelbundock/Rdatasets/blob/master/Rdatasets.R
# License: GPL-3
# Modified to remove not-in-Debian dependencies --  Rebecca Palmer
can_do_index=require(R2HTML)

# Data packages
packages = c("boot", "car", "carData", "cluster", "COUNT", "DAAG", "datasets", 
             "drc", "Ecdat", "evir", "forecast", "fpp2", "gamclass", "gap", 
             "geepack", "ggplot2", "Guerry", "HSAUR", "hwde", "ISLR", "KMsurv", 
             "lattice", "lme4", "lmec", "MASS", "mediation", "mi", "mosaicData", 
             "multgee", "plm", "plyr", "pscl", "psych", "quantreg", "reshape2", 
             "robustbase", "rpart", "sandwich", "sem", "Stat2Data", "survival", 
             "texmex", "vcd", "Zelig", "purrr")
for(package in packages) {
    require(package, character.only=TRUE)
}

# Functions
get_doc = function(package = 'mi', dataset = 'nlsyV') {
    help.ref = try(help(eval(dataset), package=eval(package)), silent = TRUE)
    out = try(utils:::.getHelpFile(help.ref), silent = TRUE)
    return(out)
}

get_data = function(package = 'mi', dataset = 'nlsyV') {
    e = new.env(hash = TRUE, parent = parent.frame(), size = 29L)
    data(list = dataset, package = package, envir = e)
    out = e[[dataset]]
    return(out)
}

tidy_data = function(dat) {
    if(class(dat)[1]=='ts'){
        dat = try(data.frame('time' = time(dat), 'value' = dat), silent = TRUE)
    } else {
        dat = try(as.data.frame(dat), silent = TRUE)
    }
    if (class(dat)[1] == 'data.frame') {
        out = dat
    } else {
        out = NA
        class(out) = 'try-error'
    }
    return(out)
}

write_data = function(i) {
    package = index$Package[i]
    dataset = index$Item[i]
    dat = data[[i]]
    doc = docs[[i]]
    cat(package, ' -- ', dataset, '\n')
    try(dir.create('csv'), silent = TRUE)
    try(dir.create('doc'), silent = TRUE)
    try(dir.create(paste0('csv/', package)), silent = TRUE)
    try(dir.create(paste0('doc/', package)), silent = TRUE)
    fn_csv = paste0('csv/', package, '/', dataset, '.csv')
    fn_doc = paste0('doc/', package, '/', dataset, '.html')
    write.csv(data[[i]], file = fn_csv)
    tools::Rd2HTML(docs[[i]], out = fn_doc)
}

# Index
index = data(package=packages)$results[,c(1,3,4)]
index = data.frame(index, stringsAsFactors=FALSE)

# Extract Data and Docs and exclude non-data.frames and errors
data = lapply(1:nrow(index), function(i) get_data(index$Package[i], index$Item[i]))
docs = lapply(1:nrow(index), function(i) get_doc(index$Package[i], index$Item[i]))
data = lapply(data, tidy_data)
idx1 = sapply(docs, class) != 'try-error'
idx2 = sapply(data, class) != 'try-error'
idx = as.logical(pmin(idx1, idx2))
data = data[idx]
docs = docs[idx]
index = index[idx,]

# remap names to what statsmodels expects
index$Package[index$Package == "Guerry"] <- "HistData" # the dataset we want is in both

# Write to file
for (i in 1:nrow(index)) {
    write_data(i)
}

# Index
is.binary <- function(x) {
    tryCatch(length(unique(na.omit(x))) == 2, 
             error = function(e) FALSE, silent = TRUE)
}
index$Rows = sapply(data, nrow)
index$Cols = sapply(data, ncol)
index$n_binary <- sapply(data, function(x) sum(sapply(x, is.binary)))
index$n_character <- sapply(data, function(x) sum(sapply(x, is.character)))
index$n_factor <- sapply(data, function(x) sum(sapply(x, is.factor)))
index$n_logical <- sapply(data, function(x) sum(sapply(x, is.logical)))
index$n_numeric <- sapply(data, function(x) sum(sapply(x, is.numeric)))

index$CSV = paste('https://raw.github.com/vincentarelbundock/Rdatasets/master/csv/',
                  index$Package, '/', index$Item, '.csv', sep='')
index$Doc = paste('https://raw.github.com/vincentarelbundock/Rdatasets/master/doc/',
                  index$Package, '/', index$Item, '.html', sep='')
index = index[order(index$Package, index$Item),]

# Index CSV
write.csv(index, file = 'datasets.csv', row.names = FALSE)

if (!can_do_index){
    print("Can't create the HTML index, as R2HTML is not installed")
    q()
}
# Index HTML
index$CSV = paste("<a href='", index$CSV, "'> CSV </a>", sep='')
index$Doc = paste("<a href='", index$Doc, "'> DOC </a>", sep='')
unlink('datasets.html')
rss = '
<style type="text/css">
  tr:nth-child(even){
          background-color: #E5E7E5;
  }
</style>
'
cat(rss, file='datasets.html')
HTML(index, file='datasets.html', row.names=FALSE, append=TRUE)

data <- read.csv('E:\\path_to_repo\\statsmodels\\datasets\\grunfeld\\grunfeld.csv')

data <- data[data$firm %in% c('General Motors','Chrysler','General Electric','Westinghouse','US Steel'),]
attach(data)
library('plm')
library('systemfit')
panel <- plm.data(data,c('firm','year'))
formula <- invest ~ value + capital
SUR <- systemfit(formula,method='SUR',data=panel)
f <- fitted(SUR)
ff <- c(f[,'Chrysler'],f[,'General.Electric'],f[,'General.Motors'],f[,'US.Steel'],f[,'Westinghouse'])

# save results to python module
#load functions, (windows path separators)
source("E:\\path_to_repo\\tools\\R2nparray\\R\\R2nparray.R")
source("E:\\path_to_repo\\tools\\topy.R")

#translation table for names  (could be dict in python)
translate = list(coefficients="params",
                 coefCov="cov_params",
                 residCovEst="resid_cov_est",
                 residCov="resid_cov",
                 df_residual="df_resid",
                 df_residual_sys="df_resid_sys",
                 #nCoef="k_vars",    #not sure about this
                 fitted_values="fittedvalues"
                 )

fname = "tmp_sur_0.py"
append = FALSE #TRUE

#redirect output to file
sink(file=fname, append=append)
write_header()
cat("\nsur = Bunch()\n")

cat_items(SUR, prefix="sur.", blacklist=c("eq", "control"), trans=translate)

equations = SUR[["eq"]]
for (ii in c(1:length(equations))) {
equ_name = paste("sur.equ", ii, sep="")
cat("\n\n", equ_name, sep=""); cat(" = Bunch()\n")
cat_items(equations[[ii]], prefix=paste(equ_name, ".", sep=""), trans=translate)
}

sink()

! fixed partition sort July 2019
! Converted to double July 2019
! Converted to FORTRAN90
! Otherwise unmodified from original
subroutine ma(x, n, len, ave)
    integer n, len, i, j, k, m, newn
    real(kind=8) x(n), ave(n), flen, v
    newn = n - len + 1
    flen = dble(len)
    v = dble(0.0)
    do i = 1, len
        v = v + x(i)
    end do
    ave(1) = v / flen
    if(.not.(newn > 1))goto 23085
    k = len
    m = 0
    do j = 2, newn
        k = k + 1
        m = m + 1
        v = v - x(m) + x(k)
        ave(j) = v / flen
    end do
    23085 continue
    return
end

subroutine ess(y, n, len, ideg, njump, userw, rw, ys, res)
    integer n, len, ideg, njump, newnj, nleft, nright, nsh, k, i, j
    real(kind=8) y(n), rw(n), ys(n), res(n), delta
    logical ok, userw
    if(.not.(n < 2))goto 23019
    ys(1) = y(1)
    return
    23019 continue
    newnj = min0(njump, n - 1)
    if(.not.(len >= n))goto 23021
    nleft = 1
    nright = n
    do i = 1, n, newnj
        call est(y, n, len, ideg, dble(i), ys(i), nleft, nright, res, userw, rw, ok)
        if(.not.(.not. ok))goto 23025
        ys(i) = y(i)
        23025 continue
    end do
    goto 23022
    23021 continue
    if(.not.(newnj == 1))goto 23027
    nsh = (len + 1) / 2
    nleft = 1
    nright = len
    do i = 1, n
        if(.not.(i > nsh  .and.  nright /= n))goto 23031
        nleft = nleft + 1
        nright = nright + 1
        23031 continue
        call est(y, n, len, ideg, dble(i), ys(i), nleft, nright, res, userw, rw, ok)
        if(.not.(.not. ok))goto 23033
        ys(i) = y(i)
        23033 continue
    end do
    goto 23028
    23027 continue
    nsh = (len + 1) / 2
    do i = 1, n, newnj
        if(.not.(i < nsh))goto 23037
        nleft = 1
        nright = len
        goto 23038
        23037 continue
        if(.not.(i >= n - nsh + 1))goto 23039
        nleft = n - len + 1
        nright = n
        goto 23040
        23039 continue
        nleft = i - nsh + 1
        nright = len + i - nsh
        23040 continue
        23038 continue
        call est(y, n, len, ideg, dble(i), ys(i), nleft, nright, res, userw, rw, ok)
        if(.not.(.not. ok))goto 23041
        ys(i) = y(i)
        23041 continue
    end do
    23028 continue
    23022 continue
    if(.not.(newnj /= 1))goto 23043
    do i = 1, n - newnj, newnj
        delta = (ys(i + newnj) - ys(i)) / dble(newnj)
        do j = i + 1, i + newnj - 1
            ys(j) = ys(i) + delta * dble(j - i)
        end do
    end do
    k = ((n - 1) / newnj) * newnj + 1
    if(.not.(k /= n))goto 23049
    call est(y, n, len, ideg, dble(n), ys(n), nleft, nright, res, userw, rw, ok)
    if(.not.(.not. ok))goto 23051
    ys(n) = y(n)
    23051 continue
    if(.not.(k /= n - 1))goto 23053
    delta = (ys(n) - ys(k)) / dble(n - k)
    do j = k + 1, n - 1
        ys(j) = ys(k) + delta * dble(j - k)
    end do
    23053 continue
    23049 continue
    23043 continue
    return
end


subroutine est(y, n, len, ideg, xs, ys, nleft, nright, w, userw, rw, ok)
    integer n, len, ideg, nleft, nright, j
    real(kind=8) y(n), w(n), rw(n), xs, ys, range, h, h1, h9, a, b, c, r
    logical userw, ok
    range = dble(n) - dble(1)
    h = amax1(xs - dble(nleft), dble(nright) - xs)
    if(.not.(len > n))goto 23057
    h = h + dble((len - n) / 2)
    23057 continue
    h9 = .999 * h
    h1 = .001 * h
    a = 0.0
    do j = nleft, nright
        w(j) = 0.
        r = abs(dble(j) - xs)
        if(.not.(r <= h9))goto 23061
        if(.not.(r <= h1))goto 23063
        w(j) = 1.
        goto 23064
        23063 continue
        w(j) = (1.0 - (r / h)**3)**3
        23064 continue
        if(.not.(userw))goto 23065
        w(j) = rw(j) * w(j)
        23065 continue
        a = a + w(j)
        23061 continue
    end do
    if(.not.(a <= 0.0))goto 23067
    ok = .false.
    goto 23068
    23067 continue
    ok = .true.
    do j = nleft, nright
        w(j) = w(j) / a
    end do
    if(.not.((h > 0.) .and. (ideg > 0)))goto 23071
    a = 0.0
    do j = nleft, nright
        a = a + w(j) * dble(j)
    end do
    b = xs - a
    c = 0.0
    do j = nleft, nright
        c = c + w(j) * (dble(j) - a)**2
    end do
    if(.not.(sqrt(c) > .001 * range))goto 23077
    b = b / c
    do j = nleft, nright
        w(j) = w(j) * (b * (dble(j) - a) + 1.0)
    end do
    23077 continue
    23071 continue
    ys = 0.0
    do j = nleft, nright
        ys = ys + w(j) * y(j)
    end do
    23068 continue
    return
end

subroutine fts(x, n, np, trend, work)
    integer n, np
    real(kind=8) x(n), trend(n), work(n)
    call ma(x, n, np, trend)
    call ma(trend, n - np + 1, np, work)
    call ma(work, n - 2 * np + 2, 3, trend)
    return
end

subroutine rwts(y, n, fit, rw)
    integer mid(2), n
    real(kind=8) y(n), fit(n), rw(n), cmad, c9, c1, r
    do i = 1, n
        rw(i) = abs(y(i) - fit(i))
    end do
    ! TODO: psort does not work correctly, reorder mid
    mid(2) = n / 2 + 1
    mid(1) = n - mid(2) + 1
    call psort(rw, n, mid, 2)
    cmad = 3.0 * (rw(mid(1)) + rw(mid(2)))
    c9 = .999 * cmad
    c1 = .001 * cmad
    do i = 1, n
        r = abs(y(i) - fit(i))
        if(.not.(r <= c1))goto 23101
        rw(i) = 1.
        goto 23102
        23101 continue
        if(.not.(r <= c9))goto 23103
        rw(i) = (1.0 - (r / cmad)**2)**2
        goto 23104
        23103 continue
        rw(i) = 0.
        23104 continue
        23102 continue
    end do
    return
end


subroutine ss(y, n, np, ns, isdeg, nsjump, userw, rw, season, work1, work2, work3, work4)
    integer n, np, ns, isdeg, nsjump, nright, nleft, i, j, k
    real(kind=8) y(n), rw(n), season(n + 2 * np), work1(n), work2(n), work3(n), work4(n), xs
    logical userw, ok
    j = 1
    23105 if(.not.(j <= np))goto 23107
    k = (n - j) / np + 1
    do i = 1, k
        work1(i) = y((i - 1) * np + j)
    end do
    if(.not.(userw))goto 23110
    do i = 1, k
        work3(i) = rw((i - 1) * np + j)
    end do
    23110 continue
    call ess(work1, k, ns, isdeg, nsjump, userw, work3, work2(2), work4)
    xs = 0
    nright = min0(ns, k)
    call est(work1, k, ns, isdeg, xs, work2(1), 1, nright, work4, userw, work3, ok)
    if(.not.(.not. ok))goto 23114
    work2(1) = work2(2)
    23114 continue
    xs = k + 1
    nleft = max0(1, k - ns + 1)
    call est(work1, k, ns, isdeg, xs, work2(k + 2), nleft, k, work4, userw, work3, ok)
    if(.not.(.not. ok))goto 23116
    work2(k + 2) = work2(k + 1)
    23116 continue
    do m = 1, k + 2
        season((m - 1) * np + j) = work2(m)
    end do
    j = j + 1
    goto 23105
    23107 continue
    return
end

subroutine onestp(y, n, np, ns, nt,nl, isdeg, itdeg, ildeg, nsjump,ntjump, nljump, ni, userw,rw, season, trend, work)
    integer n, ni, np, ns, nt, nsjump, ntjump, nl, nljump, isdeg, itdeg, ildeg
    real(kind=8) y(n), rw(n), season(n), trend(n), work(n + 2 * np, 5)
    logical userw
    do j = 1, ni
        do i = 1, n
            work(i, 1) = y(i) - trend(i)
        end do
        call ss(work(1, 1), n, np, ns, isdeg, nsjump, userw, rw, work(1, 2), work(1, 3), work(1, 4), work(1, 5), season)
        call fts(work(1, 2), n + 2 * np, np, work(1, 3), work(1, 1))
        call ess(work(1, 3), n, nl, ildeg, nljump, .false., work(1, 4), work(1, 1), work(1, 5))
        do i = 1, n
            season(i) = work(np + i, 2) - work(i, 1)
        end do
        do i = 1, n
            work(i, 1) = y(i) - season(i)
        end do
        call ess(work(1, 1), n, nt, itdeg, ntjump, userw, rw, trend, work(1, 3))
    end do
    return
end

subroutine stl(y, n, np, ns, nt,nl, isdeg, itdeg, ildeg, nsjump,ntjump, nljump, ni, no,rw, season, trend, work)
    integer n, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump,  nljump, ni, no, k
    integer newns, newnt, newnl, newnp
    real(kind=8) y(n), rw(n), season(n), trend(n), work(n + 2 * np, 5)
    logical userw
    userw = .false.
    k = 0
    do i = 1, n
        trend(i) = 0.0
    end do
    newns = max0(3, ns)
    newnt = max0(3, nt)
    newnl = max0(3, nl)
    newnp = max0(2, np)
    if(.not.(mod(newns, 2) == 0))goto 23002
    newns = newns + 1
    23002 continue
    if(.not.(mod(newnt, 2) == 0))goto 23004
    newnt = newnt + 1
    23004 continue
    if(.not.(mod(newnl, 2) == 0))goto 23006
    newnl = newnl + 1
    23006 continue
    23008 continue
    call onestp(y, n, newnp, newns, newnt, newnl, isdeg, itdeg, ildeg, nsjump, ntjump, nljump, ni, userw, rw,season, trend, work)
    k = k + 1
    if(.not.(k > no))goto 23011
    goto 23010
    23011 continue
    do i = 1, n
        work(i, 1) = trend(i) + season(i)
    end do
    call rwts(y, n, work(1, 1), rw)
    userw = .true.
    23009 goto 23008
    23010 continue
    if(.not.(no <= 0))goto 23015
    do i = 1, n
        rw(i) = 1.0
    end do
    23015 continue
    return
end


subroutine stlez(y, n, np, ns, isdeg, itdeg, robust, no, rw, season, trend, work)
    logical robust
    integer n, i, j, np, ns, no, nt, nl, ni, nsjump, ntjump, nljump, newns, newnp
    integer isdeg, itdeg, ildeg
    real(kind=8) y(n), rw(n), season(n), trend(n), work(n + 2 * np, 7)
    real(kind=8) maxs, mins, maxt, mint, maxds, maxdt, difs, dift
    ildeg = itdeg
    newns = max0(3, ns)
    if(.not.(mod(newns, 2) == 0))goto 23120
    newns = newns + 1
    23120 continue
    newnp = max0(2, np)
    nt = (1.5 * newnp) / (1 - 1.5 / newns) + 0.5
    nt = max0(3, nt)
    if(.not.(mod(nt, 2) == 0))goto 23122
    nt = nt + 1
    23122 continue
    nl = newnp
    if(.not.(mod(nl, 2) == 0))goto 23124
    nl = nl + 1
    23124 continue
    if(.not.(robust))goto 23126
    ni = 1
    goto 23127
    23126 continue
    ni = 2
    23127 continue
    nsjump = max0(1, int(dble(newns) / 10 + 0.9))
    ntjump = max0(1, int(dble(nt) / 10 + 0.9))
    nljump = max0(1, int(dble(nl) / 10 + 0.9))
    do i = 1, n
        trend(i) = 0.0
    end do
    call onestp(y, n, newnp, newns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, nljump, ni, .false., rw, season, trend, work)
    no = 0
    if(.not.(robust))goto 23130
    j = 1
    23132 if(.not.(j <= 15))goto 23134
    do i = 1, n
        work(i, 6) = season(i)
        work(i, 7) = trend(i)
        work(i, 1) = trend(i) + season(i)
    end do
    call rwts(y, n, work(1, 1), rw)
    call onestp(y, n, newnp, newns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, nljump, ni, .true., rw, season, trend, work)
    no = no + 1
    maxs = work(1, 6)
    mins = work(1, 6)
    maxt = work(1, 7)
    mint = work(1, 7)
    maxds = abs(work(1, 6) - season(1))
    maxdt = abs(work(1, 7) - trend(1))
    do i = 2, n
        if(.not.(maxs < work(i, 6)))goto 23139
        maxs = work(i, 6)
        23139 continue
        if(.not.(maxt < work(i, 7)))goto 23141
        maxt = work(i, 7)
        23141 continue
        if(.not.(mins > work(i, 6)))goto 23143
        mins = work(i, 6)
        23143 continue
        if(.not.(mint > work(i, 7)))goto 23145
        mint = work(i, 7)
        23145 continue
        difs = abs(work(i, 6) - season(i))
        dift = abs(work(i, 7) - trend(i))
        if(.not.(maxds < difs))goto 23147
        maxds = difs
        23147 continue
        if(.not.(maxdt < dift))goto 23149
        maxdt = dift
        23149 continue
    end do
    if(.not.((maxds / (maxs - mins) < .01)  .and.  (maxdt / (maxt - mint) < .01)))goto 23151
    goto 23134
    23151 continue
    j = j + 1
    goto 23132
    23134 continue
    23130 continue
    if(.not.(.not. robust))goto 23153
    do i = 1, n
        rw(i) = 1.0
    end do
    23153 continue
    return
end


subroutine psort(a, n, ind, ni)
    real(kind=8) a(n)
    integer n, ind(ni), ni
    integer indu(16), indl(16), iu(16), il(16), p, jl, ju, i, j, m, k, ij, l
    real(kind=8) t, tt
    if(.not.(n < 0 .or. ni < 0))goto 23157
    return
    23157 continue
    if(.not.(n < 2  .or.  ni == 0))goto 23159
    return
    23159 continue
    jl = 1
    ju = ni
    indl(1) = 1
    indu(1) = ni
    i = 1
    j = n
    m = 1
    23161 continue
    if(.not.(i < j))goto 23164
    go to 10
    23164 continue
    23166 continue
    m = m - 1
    if(.not.(m == 0))goto 23169
    goto 23163
    23169 continue
    i = il(m)
    j = iu(m)
    jl = indl(m)
    ju = indu(m)
    if(.not.(jl <= ju))goto 23171
    23173 if(.not.(j - i > 10))goto 23174
    10    k = i
    ij = (i + j) / 2
    t = a(ij)
    if(.not.(a(i) > t))goto 23175
    a(ij) = a(i)
    a(i) = t
    t = a(ij)
    23175 continue
    l = j
    if(.not.(a(j) < t))goto 23177
    a(ij) = a(j)
    a(j) = t
    t = a(ij)
    if(.not.(a(i) > t))goto 23179
    a(ij) = a(i)
    a(i) = t
    t = a(ij)
    23179 continue
    23177 continue
    23181 continue
    l = l - 1
    if(.not.(a(l) <= t))goto 23184
    tt = a(l)
    23186 continue
    k = k + 1
    23187 if(.not.(a(k) >= t))goto 23186
    if(.not.(k > l))goto 23189
    goto 23183
    23189 continue
    a(l) = a(k)
    a(k) = tt
    23184 continue
    23182 goto 23181
    23183 continue
    indl(m) = jl
    indu(m) = ju
    p = m
    m = m + 1
    if(.not.(l - i <= j - k))goto 23191
    il(p) = k
    iu(p) = j
    j = l
    23193 continue
    if(.not.(jl > ju))goto 23196
    goto 23167
    23196 continue
    if(.not.(ind(ju) <= j))goto 23198
    goto 23195
    23198 continue
    ju = ju - 1
    23194 goto 23193
    23195 continue
    indl(p) = ju + 1
    goto 23192
    23191 continue
    il(p) = i
    iu(p) = l
    i = k
    23200 continue
    if(.not.(jl > ju))goto 23203
    goto 23167
    23203 continue
    if(.not.(ind(jl) >= i))goto 23205
    goto 23202
    23205 continue
    jl = jl + 1
    23201 goto 23200
    23202 continue
    indu(p) = jl - 1
    23192 continue
    goto 23173
    23174 continue
    if(.not.(i == 1))goto 23207
    goto 23168
    23207 continue
    i = i - 1
    23209 continue
    i = i + 1
    if(.not.(i == j))goto 23212
    goto 23211
    23212 continue
    t = a(i + 1)
    if(.not.(a(i) > t))goto 23214
    k = i
    23216 continue
    a(k + 1) = a(k)
    k = k - 1
    23217 if(.not.(t >= a(k)))goto 23216
    a(k + 1) = t
    23214 continue
    23210 goto 23209
    23211 continue
    23171 continue
    23167 goto 23166
    23168 continue
    23162 goto 23161
    23163 continue
    return
end

dta <- read.csv("/home/skipper/statsmodels/statsmodels-skipper/statsmodels/datasets/macrodata/macrodata.csv")

cpi <- dta$cpi

/* this automatically suppresses the constant */
mod111 <- arima(cpi, order=c(1,1,1), method="CSS")
/*you can use xreg=1:length(cpi)*/

dcpi <- diff(cpi)

mod111 <- arima(dcpi, order=c(1,0,1), method="CSS")
bse <- sqrt(diag(mod111$var.coef))
tvalues <- mod111$coef / bse
pvalues <- (1 - pt(abs(tvalues), 198)) * 2

/* use starting values from X-ARIMA */
mod112 <- arima(dcpi, order=c(1,0,2), method="CSS", init=c(-0.692425, 1.07366, 0.172024, 0.905322))
bse <- sqrt(diag(mod112$var.coef))
tvalues <- mod112$coef / bse
pvalues <- (1 - pt(abs(tvalues), 198)) * 2

library(KFAS)
options(digits=10)

# should run this from the statsmodels/statsmodels directory
dta <- read.csv('tsa/statespace/tests/results/results_wpi1_ar3_stata.csv')
matlab <- read.csv('tsa/statespace/tests/results/results_wpi1_missing_ar3_matlab_ssm.csv')
names(matlab) <- c(
  'a1','a2','a3','detP','alphahat1','alphahat2','alphahat3',
  'detV','eps','epsvar','eta','etavar')

endog <- diff(dta$wpi)

Z <- matrix(c(1, 0, 0), nrow=1, ncol=3)
H <- matrix(0, nrow=1, ncol=1)
T <- t(matrix(
  c(.5270715, .0952613, .2580355,
    1,        0,        0,
    0,        1,        0), nrow=3, ncol=3))
Q <- matrix(.5307459, nrow=1, ncol=1)
R <- matrix(0, nrow=3, ncol=1)
R[1,1] <- 1
P <- t(matrix(
  c(1.58276997,  1.24351589,  1.12706975,
    1.24351589,  1.58276997,  1.24351589,
    1.12706975,  1.24351589,  1.58276997), nrow=3, ncol=3))

mod <- SSModel(endog ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1=P),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)

# kf$logLik # -130.0310409

# r = scaled_smoothed_estimator
# N = scaled_smoothed_estimator_cov
# m = forecasts
# v = forecasts_error
# F = forecasts_error_cov
# a = predicted_state
# P = predicted_state_cov
# mu = filtered_forecasts
# alphahat = smoothed_state
# V = smoothed_state_cov
# muhat = smoothed_forecasts
# etahat = smoothed_state_disturbance
# V_eta = smoothed_state_disturbance_cov
# epshat = smoothed_measurement_disturbance
# V_eps = smoothed_measurement_disturbance_cov

out <- as.data.frame(with(kf, cbind(
  t(r)[2:124,], apply(N, 3, det)[2:124],
  m, apply(P_mu, 3, det), v, t(F),
  a[2:124,], apply(P, 3, det)[2:124],
  alphahat, apply(V, 3, det),
  muhat, apply(V_mu, 3, det),
  etahat, apply(V_eta, 3, det), epshat, t(V_eps)
)))
names(out) <- c(
  "r1", "r2", "r3", "detN",
  "m", "detPmu",
  "v", "F",
  "a1", "a2", "a3", "detP",
  "alphahat1", "alphahat2", "alphahat3", "detV",
  "muhat", "detVmu",
  "etahat", "detVeta",
  "epshat", "Veps"
)
write.csv(out, 'tsa/statespace/tests/results/results_smoothing3_R.csv', row.names=FALSE)

library(plyr)
library(vars)
# library(MTS)
library(readstata13)
options(digits=15, scipen=999)

dta <- read.dta13('~/projects/statsmodels/statsmodels/tsa/tests/results/lutkepohl2.dta')

# TODO
# predict(res, dumvar=exog_fcast)
# vars::fevd(res)
# vars::irf(res)

extract_var_output <- function(res, k_trend=0, k_exog=0) {
  s <- summary(res)
  
  # Coefficient vectors
  coeffs <- vector("list", res$K)
  for(i in 1:res$K) {
    coeffs[[i]] <- t(res$varresult[[i]]$coefficients)
  }
  coeffs <- rbind.fill.matrix(coeffs)
  
  # Reorder
  k <- res$K * res$p
  k1 <- k + k_trend
  k2 <- ncol(coeffs)
  
  trend <- c()
  if (k_trend > 0) {
    trend <- t(coeffs[,(k + 1):k1])
  }
  
  var <- t(coeffs[,1:k])
  
  exog <- c()
  if (k_exog > 0) {
    exog <- t(coeffs[,(k1 + 1):k2])
  }
  
  # Error variance
  # Have to compute this by hand since the definition used
  # in the log-likelihood computation is not the same as that
  # given by summary
  resids <- resid(res)
  Sigma <- (t(resids) %*% resids) / res$obs
  U <- chol(Sigma)
  params <- c(trend, var, exog, U[upper.tri(U, diag=TRUE)])
  
  return(list(coeffs=coeffs, params=params, s=s))
}

# "res_basic"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
res <- vars::VAR(endog, p=2, type="none")
out <- extract_var_output(res, k_trend=0)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_basic <- as.data.frame(predict(res)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_basic) <- paste0('basic.fcast.', names(fcasts_basic))
irfs_basic <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_basic) <- paste0('basic.irf.', names(irfs_basic))
irfs_basic_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_basic_ortho) <- paste0('basic.irf.ortho.', names(irfs_basic_ortho))
irfs_basic_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_basic_cumu) <- paste0('basic.irf.cumu.', names(irfs_basic_cumu))
fevd_basic <- vars::fevd(res)
fevd_basic <- as.data.frame(cbind(fevd_basic[[1]], fevd_basic[[2]], fevd_basic[[3]]))
names(fevd_basic)  <- paste0('basic.fevd.', names(fevd_basic))

# "res_c"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
res <- vars::VAR(endog, p=2, type="const")
out <- extract_var_output(res, k_trend=1)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_c <- as.data.frame(predict(res)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_c) <- paste0('c.fcast.', names(fcasts_c))
irfs_c <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_c) <- paste0('c.irf.', names(irfs_c))
irfs_c_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_c_ortho) <- paste0('c.irf.ortho.', names(irfs_c_ortho))
irfs_c_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_c_cumu) <- paste0('c.irf.cumu.', names(irfs_c_cumu))
fevd_c <- vars::fevd(res)
fevd_c <- as.data.frame(cbind(fevd_c[[1]], fevd_c[[2]], fevd_c[[3]]))
names(fevd_c)  <- paste0('c.fevd.', names(fevd_c))

# "res_ct"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
res <- vars::VAR(endog, p=2, type="both")
out <- extract_var_output(res, k_trend=2)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_ct <- as.data.frame(predict(res)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_ct) <- paste0('ct.fcast.', names(fcasts_ct))
irfs_ct <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_ct) <- paste0('ct.irf.', names(irfs_ct))
irfs_ct_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_ct_ortho) <- paste0('ct.irf.ortho.', names(irfs_ct_ortho))
irfs_ct_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_ct_cumu) <- paste0('ct.irf.cumu.', names(irfs_ct_cumu))
fevd_ct <- vars::fevd(res)
fevd_ct <- as.data.frame(cbind(fevd_ct[[1]], fevd_ct[[2]], fevd_ct[[3]]))
names(fevd_ct)  <- paste0('ct.fevd.', names(fevd_ct))

# "res_ct_as_exog0"
# here we start the trend at zero
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
exog <- cbind(rep(1, 75), 0:74)
exog_fcast <- cbind(rep(1, 10), 75:84)
# exog <- cbind(rep(1, 75), 1:75, (1:75)^2)
res <- vars::VAR(endog, p=2, type="none", exogen=exog)
out <- extract_var_output(res, k_trend=0, k_exog=2)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_ct_as_exog0 <- as.data.frame(predict(res, dumvar=exog_fcast)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_ct_as_exog0) <- paste0('ct_as_exog0.fcast.', names(fcasts_ct_as_exog0))
irfs_ct_as_exog0 <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_ct_as_exog0) <- paste0('ct_as_exog0.irf.', names(irfs_ct_as_exog0))
irfs_ct_as_exog0_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_ct_as_exog0_ortho) <- paste0('ct_as_exog0.irf.ortho.', names(irfs_ct_as_exog0_ortho))
irfs_ct_as_exog0_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_ct_as_exog0_cumu) <- paste0('ct_as_exog0.irf.cumu.', names(irfs_ct_as_exog0_cumu))
fevd_ct_as_exog0 <- vars::fevd(res)
fevd_ct_as_exog0 <- as.data.frame(cbind(fevd_ct_as_exog0[[1]], fevd_ct_as_exog0[[2]], fevd_ct_as_exog0[[3]]))
names(fevd_ct_as_exog0)  <- paste0('ct_as_exog0.fevd.', names(fevd_ct_as_exog0))

# "res_ctt_as_exog1"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
exog <- cbind(rep(1, 75), 1:75, (1:75)^2)
exog_fcast <- cbind(rep(1, 10), 76:85, (76:85)^2)
res <- vars::VAR(endog, p=2, type='none', exogen=exog)
out <- extract_var_output(res, k_trend=0, k_exog=3)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_ctt_as_exog1 <- as.data.frame(predict(res, dumvar=exog_fcast)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_ctt_as_exog1) <- paste0('ctt_as_exog1.fcast.', names(fcasts_ctt_as_exog1))
irfs_ctt_as_exog1 <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_ctt_as_exog1) <- paste0('ctt_as_exog1.irf.', names(irfs_ctt_as_exog1))
irfs_ctt_as_exog1_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_ctt_as_exog1_ortho) <- paste0('ctt_as_exog1.irf.ortho.', names(irfs_ctt_as_exog1_ortho))
irfs_ctt_as_exog1_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_ctt_as_exog1_cumu) <- paste0('ctt_as_exog1.irf.cumu.', names(irfs_ctt_as_exog1_cumu))
fevd_ctt_as_exog1 <- vars::fevd(res)
fevd_ctt_as_exog1 <- as.data.frame(cbind(fevd_ctt_as_exog1[[1]], fevd_ctt_as_exog1[[2]], fevd_ctt_as_exog1[[3]]))
names(fevd_ctt_as_exog1)  <- paste0('ctt_as_exog1.fevd.', names(fevd_ctt_as_exog1))

# "res_ct_exog"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
exog <- dta[2:76,c('inc')]
exog_fcast <- matrix(dta[77:86,'inc'], nrow=10, ncol=1)
names(exog_fcast) <- c('inc')
res <- vars::VAR(endog, p=2, type='both', exogen=exog)
out <- extract_var_output(res, k_trend=2, k_exog=1)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_ct_exog <- as.data.frame(predict(res, dumvar=exog_fcast)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_ct_exog) <- paste0('ct_exog.fcast.', names(fcasts_ct_exog))
irfs_ct_exog <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_ct_exog) <- paste0('ct_exog.irf.', names(irfs_ct_exog))
irfs_ct_exog_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_ct_exog_ortho) <- paste0('ct_exog.irf.ortho.', names(irfs_ct_exog_ortho))
irfs_ct_exog_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_ct_exog_cumu) <- paste0('ct_exog.irf.cumu.', names(irfs_ct_exog_cumu))
fevd_ct_exog <- vars::fevd(res)
fevd_ct_exog <- as.data.frame(cbind(fevd_ct_exog[[1]], fevd_ct_exog[[2]], fevd_ct_exog[[3]]))
names(fevd_ct_exog)  <- paste0('ct_exog.fevd.', names(fevd_ct_exog))


# "res_c_2exog"
endog <- dta[2:76,c('dln_inv', 'dln_inc', 'dln_consump')]
exog <- dta[2:76,c('inc', 'inv')]
exog_fcast <- dta[77:86,c('inc', 'inv')]
res <- vars::VAR(endog, p=2, type='const', exogen=exog)
out <- extract_var_output(res, k_trend=1, k_exog=2)
cat(out$s$logLik)
cat(out$params, sep=', ')
fcasts_c_2exog <- as.data.frame(predict(res, dumvar=exog_fcast)$fcst)[c(1,4,5,8,9,12)]
names(fcasts_c_2exog) <- paste0('c_2exog.fcast.', names(fcasts_c_2exog))
irfs_c_2exog <- as.data.frame(vars::irf(res, ortho=FALSE, boot=FALSE)$irf)
names(irfs_c_2exog) <- paste0('c_2exog.irf.', names(irfs_c_2exog))
irfs_c_2exog_ortho <- as.data.frame(vars::irf(res, ortho=TRUE, boot=FALSE)$irf)
names(irfs_c_2exog_ortho) <- paste0('c_2exog.irf.ortho.', names(irfs_c_2exog_ortho))
irfs_c_2exog_cumu <- as.data.frame(vars::irf(res, cumulative=TRUE, boot=FALSE)$irf)
names(irfs_c_2exog_cumu) <- paste0('c_2exog.irf.cumu.', names(irfs_c_2exog_cumu))
fevd_c_2exog <- vars::fevd(res)
fevd_c_2exog <- as.data.frame(cbind(fevd_c_2exog[[1]], fevd_c_2exog[[2]], fevd_c_2exog[[3]]))
names(fevd_c_2exog)  <- paste0('c_2exog.fevd.', names(fevd_c_2exog))

cbind.fill <- function(...){
  nm <- list(...) 
  nm <- lapply(nm, as.matrix)
  n <- max(sapply(nm, nrow)) 
  do.call(cbind, lapply(nm, function (x) 
    rbind(x, matrix(, n-nrow(x), ncol(x))))) 
}

# Combine forecasts, irfs, etc
output <- cbind.fill(
  fcasts_basic, fcasts_c, fcasts_ct, fcasts_ct_as_exog0,
  fcasts_ctt_as_exog1, fcasts_ct_exog, fcasts_c_2exog,
  irfs_basic, irfs_c, irfs_ct, irfs_ct_as_exog0,
  irfs_ctt_as_exog1, irfs_ct_exog, irfs_c_2exog,
  irfs_basic_ortho, irfs_c_ortho, irfs_ct_ortho, irfs_ct_as_exog0_ortho,
  irfs_ctt_as_exog1_ortho, irfs_ct_exog_ortho, irfs_c_2exog_ortho,
  irfs_basic_cumu, irfs_c_cumu, irfs_ct_cumu, irfs_ct_as_exog0_cumu,
  irfs_ctt_as_exog1_cumu, irfs_ct_exog_cumu, irfs_c_2exog_cumu,
  fevd_basic, fevd_c, fevd_ct, fevd_ct_as_exog0,
  fevd_ctt_as_exog1, fevd_ct_exog, fevd_c_2exog)
write.csv(output, '~/projects/statsmodels/statsmodels/tsa/statespace/tests/results/results_var_R_output.csv')

library(R2nparray)

x <- c(-50, 175, 149, 214, 247, 237, 225, 329, 729, 809, 530, 489, 540, 457, 
         195, 176, 337, 239, 128, 102, 232, 429, 3, 98, 43, -141, -77, -13, 
         125, 361, -45, 184)
x <- ts(x, start=c(1951, 1), frequency=4)


conv2 <- filter(x, c(.75, .25), method="convolution")

conv1 <- filter(x, c(.75, .25), method="convolution", sides=1)

recurse <- filter(x, c(.75, .25), method="recursive")

recurse.init <- filter(x, c(.75, .25), method="recursive", init=c(150, 100))

conv2.odd <- filter(x, c(.75, .5, .3, .2, .1), method="convolution", 
                     sides=2)
conv1.odd <- filter(x, c(.75, .5, .3, .2, .1), method="convolution", 
                     sides=1)
recurse.odd <- filter(x, c(.75, .5, .3, .2, .1), method="recursive", 
                       init=c(150, 100, 125, 135, 145))

# missing values

x[10] = NaN

conv2.na <- filter(x, c(.75, .25), method="convolution")

conv1.na <- filter(x, c(.75, .25), method="convolution", sides=1)

recurse.na <- filter(x, c(.75, .25), method="recursive")

recurse.init.na <- filter(x, c(.75, .25), method="recursive", init=c(150, 100))


options(digits=12)

R2nparray(list(conv2=as.numeric(conv2), conv1=as.numeric(conv1), 
               recurse=as.numeric(recurse), 
               recurse_init=as.numeric(recurse.init),
               conv2_na=as.numeric(conv2.na), conv1_na=as.numeric(conv1.na), 
               recurse_na=as.numeric(recurse.na), 
               recurse_init_na=as.numeric(recurse.init.na),
               conv2_odd=as.numeric(conv2.odd),
               conv1_odd=as.numeric(conv1.odd),
               recurse_odd=as.numeric(recurse.odd)),
          fname="filter_results.py")

library(quantreg)
library(strucchange)

macrodata <- read.csv('/Users/fulton/projects/statsmodels/statsmodels/datasets/macrodata/macrodata.csv')

y <- macrodata$cpi
X <- cbind(rep(1, nrow(macrodata)), macrodata$m1)
rec_beta <- lm.fit.recursive(X, y, int=FALSE)
rec_resid <- recresid(cpi ~ 1 + m1, data=macrodata)
cusum <- efp(cpi ~ 1 + m1, data=macrodata, type=c("Rec-CUSUM"))

output <- data.frame(cbind(t(rec_beta[,3:203]), rec_resid, cusum$process[2:202]))
names(output) <- c('beta1', 'beta2', 'rec_resid', 'cusum')
write.csv(output, '/Users/fulton/projects/statsmodels/statsmodels/regression/tests/results/results_rls_R.csv', row.names=FALSE)
print(cusum$sigma)  # 9.163565

library(KFAS)
options(digits=10)

# should run this from the statsmodels/statsmodels directory
dta <- read.csv('datasets/macrodata/macrodata.csv')
obs <- diff(log(data.matrix(dta[c('realgdp','realcons','realinv')])))[1:9,]

T <- t(matrix(
  c(-0.1119908792, 0.8441841604,  0.0238725303,
    0.2629347724, 0.4996718412, -0.0173023305,
    -3.2192369082, 4.1536028244,  0.4514379215), nrow=3, ncol=3))
Q <- t(matrix(
  c(0.0000640649, 0.0000388496, 0.0002148769,
    0.0000388496, 0.0000572802, 0.000001555,
    0.0002148769, 0.000001555,  0.0017088585), nrow=3, ncol=3))
H <- t(matrix(
  c(0.0000640649, 0.,           0.,
    0.,           0.0000572802, 0.,
    0.,           0.,           0.0017088585), nrow=3, ncol=3))

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
kf$logLik # 39.01246166

# - Test 0 ------------------------------------------------------------------ #

# use fixInNamespace(simHelper, 'KFAS') to set u to zeros
# u <- rep(0, dfu * nsim)
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
sim_eps <- simulateSSM(mod, type=c("epsilon"))
sim_state <- simulateSSM(mod, type=c("states"))
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing0.csv', row.names=FALSE)

# - Test 1 ------------------------------------------------------------------ #

# use fixInNamespace(simHelper, 'KFAS') to set u to zeros, except set eps
# variates to arange / 10
# u[1:(dfeps * nsim)] = (0:(dfeps * nsim - 1))/10
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
sim_eps <- simulateSSM(mod, type=c("epsilon"))
sim_state <- simulateSSM(mod, type=c("states"))
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing1.csv', row.names=FALSE)

# - Test 2 ------------------------------------------------------------------ #

# use fixInNamespace(simHelper, 'KFAS') to set a1plus to zeros, set eps and eta
# variates to arange / 10
# u[1:(dfeps * nsim)] = (0:(dfeps * nsim - 1))/10
# u[(dfeps * nsim + 1):(dfeps * nsim + dfeta * nsim)] = (0:(dfeps * nsim - 1))/10
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
sim_eps <- simulateSSM(mod, type=c("epsilon"))
sim_state <- simulateSSM(mod, type=c("states"))
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing2.csv', row.names=FALSE)

# - Test 3 ------------------------------------------------------------------ #

# Reset obs to full dataset
obs <- diff(log(data.matrix(dta[c('realgdp','realcons','realinv')])))

T <- t(matrix(
  c(-0.1119908792, 0.8441841604,  0.0238725303,
    0.2629347724, 0.4996718412, -0.0173023305,
    -3.2192369082, 4.1536028244,  0.4514379215), nrow=3, ncol=3))
Q <- t(matrix(
  c(0.0000640649, 0.0000388496, 0.0002148769,
    0.0000388496, 0.0000572802, 0.000001555,
    0.0002148769, 0.000001555,  0.0017088585), nrow=3, ncol=3))
H <- t(matrix(
  c(0.0000640649, 0.,           0.,
    0.,           0.0000572802, 0.,
    0.,           0.,           0.0017088585), nrow=3, ncol=3))

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
kf$logLik # 1695.34872

# if run sequentially, use fixInNamespace(simHelper, 'KFAS') to remove the
# modifications to u
# Instead, capture the actual variates drawn here
set.seed(1234)
variates <- rnorm(6 * nrow(obs) + 3, mean = 0, sd = 1)
# Note: need to reset the seed before each call to make sure we always use
# the same variates.
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
set.seed(1234)
sim_eps <- simulateSSM(mod, type=c("epsilon"))
set.seed(1234)
sim_state <- simulateSSM(mod, type=c("states"))
set.seed(1234)
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(variates, 'tsa/statespace/tests/results/results_simulation_smoothing3_variates.csv', row.names=FALSE)
write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing3.csv', row.names=FALSE)

# - Test 4 ------------------------------------------------------------------ #

# Now with some fully missing observations
obs <- diff(log(data.matrix(dta[c('realgdp','realcons','realinv')])))
obs[1:50,] <- NaN

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
kf$logLik # 1305.739288

# The actual variates will be the same as in the Test 3
# Note: need to reset the seed before each call to make sure we always use
# the same variates.
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
set.seed(1234)
sim_eps <- simulateSSM(mod, type=c("epsilon"))
set.seed(1234)
sim_state <- simulateSSM(mod, type=c("states"))
set.seed(1234)
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing4.csv', row.names=FALSE)

# - Test 5 ------------------------------------------------------------------ #

# Now with some partially missing observations
obs <- diff(log(data.matrix(dta[c('realgdp','realcons','realinv')])))
obs[1:50,1] <- NaN

# The actual variates will be the same as in the Test 3
mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
kf$logLik # 1518.449598

# The actual variates will be the same as in the Test 3
# Note: need to reset the seed before each call to make sure we always use
# the same variates.
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
set.seed(1234)
sim_eps <- simulateSSM(mod, type=c("epsilon"))
set.seed(1234)
sim_state <- simulateSSM(mod, type=c("states"))
set.seed(1234)
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing5.csv', row.names=FALSE)

# - Test 6 ------------------------------------------------------------------ #

# Now with both fully and partially missing observations
obs <- diff(log(data.matrix(dta[c('realgdp','realcons','realinv')])))

obs[1:50,1] <- NaN
obs[20:70,2] <- NaN
obs[40:90,3] <- NaN
obs[120:130,1] <- NaN
obs[120:130,3] <- NaN
obs[193:202,] <- NaN

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
kf$logLik # 1108.341725

# The actual variates will be the same as in the Test 3
# Note: need to reset the seed before each call to make sure we always use
# the same variates.
set.seed(1234)
sim_eta <- simulateSSM(mod, type=c("eta"))
set.seed(1234)
sim_eps <- simulateSSM(mod, type=c("epsilon"))
set.seed(1234)
sim_state <- simulateSSM(mod, type=c("states"))
set.seed(1234)
sim_signal <- simulateSSM(mod, type=c("signals"))

out <- as.data.frame(list(sim_eta, sim_eps, sim_state, sim_signal))
names(out) <- c(
  'eta1', 'eta2', 'eta3',
  'eps1', 'eps2', 'eps3',
  'state1', 'state2', 'state3',
  'signal1', 'signal2', 'signal3'
)

write.csv(out, 'tsa/statespace/tests/results/results_simulation_smoothing6.csv', row.names=FALSE)

library(glmnet)
library(R2nparray)

# Run the glmnet lasso (elastic net) on all the test data sets

data = read.csv("lasso_data.csv", header=FALSE)

ik = 0
rslt = list()

for (n in c(100, 200, 300)) {
    for (p in c(2, 3, 5)) {

        endog = data[1:n, 1]
        exog = data[1:n, 2:(p+1)]
        exog = as.matrix(exog)

        endog = (endog - mean(endog)) / sd(endog)
        for (k in 1:p) {
            exog[,k] = exog[,k] - mean(exog[,k])
            exog[,k] = exog[,k] / sd(exog[,k])
        }

        for (alpha in c(0, 0.5, 1)) {

            fit = glmnet(exog, endog, intercept=FALSE, standardize=FALSE, alpha=alpha)

            for (q in c(0.3, 0.5, 0.7)) {
                ii = round(q * length(fit$lambda))
                coefs = coef(fit, s=fit$lambda[ii])
                coefs = coefs[2:length(coefs)]
                rname = sprintf("rslt_%d", ik)
                ik = ik + 1
                rslt[[rname]] = c(n, p, alpha, fit$lambda[ii], coefs)
            }
        }
    }
}

R2nparray(rslt, fname="glmnet_r_results.py")

library(KFAS)
# library(rucm)
options(digits=10)

dta <- read.csv('datasets/macrodata/macrodata.csv')

# Irregular (ntrend)
mod_ntrend <- SSModel(
  dta$unemp ~ -1 + SSMcustom(Z=matrix(0), matrix(0), matrix(0),
                             matrix(0)),
  H=matrix(NA))
res_ntrend <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_ntrend,
                     method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_ntrend$optim.out$par)) # 36.74687342
print(res_ntrend$optim.out$value)    # 653.8562525

# ----------------------------------------------------------------------------

# Irregular + Deterministic trend (dconstant)
mod_dconstant <- SSModel(dta$unemp ~ SSMtrend(Q=matrix(0)), H=matrix(NA))
res_dconstant <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_dconstant,
                        method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_dconstant$optim.out$par)) # 2.127438969
print(res_dconstant$optim.out$value)    # 365.5289923

# ----------------------------------------------------------------------------

# Local level (llevel)
mod_llevel <- SSModel(dta$unemp ~ SSMtrend(Q=matrix(NA)), H=matrix(NA))
res_llevel <- fitSSM(inits=c(log(var(dta$unemp)), log(var(dta$unemp))),
                     model=mod_llevel, method="BFGS",
                     control=list(REPORT=1, trace=1))

print(exp(res_llevel$optim.out$par)) # [1.182078808e-01, 4.256647886e-06]
print(res_llevel$optim.out$value)    # 70.97242557

# ----------------------------------------------------------------------------

# Random walk (rwalk)
mod_rwalk <- SSModel(dta$unemp ~ SSMtrend(Q=matrix(NA)), H=matrix(0))
res_rwalk <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_rwalk,
                    method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_rwalk$optim.out$par)) # 0.1182174646
print(res_rwalk$optim.out$value)    # 70.96771641

# ----------------------------------------------------------------------------

# Deterministic trend (dtrend)
mod_dtrend <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(0), matrix(0))),
                      H=matrix(NA))
res_dtrend <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_dtrend,
                     method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_dtrend$optim.out$par)) # 2.134137554
print(res_dtrend$optim.out$value)    # 370.7758666

# ----------------------------------------------------------------------------

# Local level with deterministic trend (lldtrend)
mod_lldtrend <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(NA), matrix(0))),
                        H=matrix(NA))
res_lldtrend <- fitSSM(inits=c(log(var(dta$unemp)), log(var(dta$unemp))),
                       model=mod_lldtrend, method="BFGS",
                       control=list(REPORT=1, trace=1))

print(exp(res_lldtrend$optim.out$par)) # [1.184455029e-01, 4.457592057e-06]
print(res_lldtrend$optim.out$value)    # 73.47291031

# ----------------------------------------------------------------------------

# Random walk with drift (rwdrift)
mod_rwdrift <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(NA), matrix(0))),
                       H=matrix(0))
res_rwdrift <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_rwdrift,
                      method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_rwdrift$optim.out$par)) # [0.1184499547]
print(res_rwdrift$optim.out$value)    # 73.46798576

# ----------------------------------------------------------------------------

# Local linear trend (lltrend)
mod_lltrend <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(NA), matrix(NA))),
                       H=matrix(NA))
res_lltrend <- fitSSM(inits=c(log(var(dta$unemp)), log(var(dta$unemp)),
                              log(var(dta$unemp))),
                      model=mod_lltrend, method="BFGS",
                      control=list(REPORT=1, trace=1))

print(exp(res_lltrend$optim.out$par)) # [1.008704925e-02, 6.091760810e-02,
                                      #  1.339852549e-06]
print(res_lltrend$optim.out$value)    # 31.15640107

# ----------------------------------------------------------------------------

# Smooth trend (strend)
mod_strend <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(0), matrix(NA))),
                      H=matrix(NA))
res_strend <- fitSSM(inits=c(log(var(dta$unemp)), log(var(dta$unemp))),
                     model=mod_strend, method="BFGS",
                     control=list(REPORT=1, trace=1))

print(exp(res_strend$optim.out$par)) # [0.0753064234342, 0.0008824099119]
print(res_strend$optim.out$value)    # 31.92261408

# ----------------------------------------------------------------------------

# Random trend (rtrend)
mod_rtrend <- SSModel(dta$unemp ~ SSMtrend(2, Q=list(matrix(0), matrix(NA))),
                      H=matrix(0))
res_rtrend <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_rtrend,
                     method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_rtrend$optim.out$par)) # [0.08054724989]
print(res_rtrend$optim.out$value)    # 32.05607557

# ----------------------------------------------------------------------------

# Cycle (exact diffuse) (with fixed period=10, cycle variance=0.1)
mod_cycle <- SSModel(dta$unemp ~ -1 + SSMcycle(10, Q=matrix(0.1)),
                     H=matrix(NA))
res_cycle <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_cycle,
                    method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_cycle$optim.out$par)) # [37.57197079]
print(res_cycle$optim.out$value)    # 656.6568684

# Cycle (approximate diffuse) (with fixed period=10, cycle variance=0.1)
# Note: matching this requires setting loglikelihood_burn = 0
mod_cycle_approx_diffuse <- SSModel(
  dta$unemp ~ -1 + SSMcycle(10, Q=matrix(0.1), P1=diag(2)*1e6), H=matrix(NA))
res_cycle_approx_diffuse <- fitSSM(inits=c(log(var(dta$unemp))),
                     model=mod_cycle_approx_diffuse, method="BFGS",
                     control=list(REPORT=1, trace=1))

print(exp(res_cycle_approx_diffuse$optim.out$par)) # [37.57197224]
print(res_cycle_approx_diffuse$optim.out$value)    # 672.3102588

# ----------------------------------------------------------------------------

# Seasonal (exact diffuse) (with fixed period=4, seasonal variance=0.1)
mod_seasonal <- SSModel(
  dta$unemp ~ -1 + SSMseasonal(4, Q=matrix(0.1), sea.type='dummy'),
  H=matrix(NA))
res_seasonal <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_seasonal,
                       method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_seasonal$optim.out$par)) # [38.17043009]
print(res_seasonal$optim.out$value)    # 655.3337155

# Seasonal (approximate diffuse) (with fixed period=4, seasonal variance=0.1)
# Note: matching this requires setting loglikelihood_burn=0
mod_seasonal_approx_diffuse <- SSModel(
  dta$unemp ~ -1 + SSMseasonal(4, Q=matrix(0.1), sea.type='dummy',
                               P1=diag(rep(1e6, 3))),
  H=matrix(NA))
res_seasonal_approx_diffuse <- fitSSM(
  inits=c(log(var(dta$unemp))), model=mod_seasonal_approx_diffuse,
  method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_seasonal_approx_diffuse$optim.out$par)) # [38.1704278]
print(res_seasonal_approx_diffuse$optim.out$value)    # 678.8138005

# ----------------------------------------------------------------------------

# Trig Seasonal (exact diffuse)
# (with fixed period=5, full number of harmonics, seasonal variance=.05)
mod_trig_seasonal <- SSModel(
  dta$unemp ~ -1 + SSMseasonal(5, Q=0.05, sea.type='trigonometric'),
  H=matrix(NA))
res_trig_seasonal <- fitSSM(
  inits=c(log(var(dta$unemp))), model=mod_trig_seasonal, method="BFGS",
  control=list(REPORT=1, trace=1))

print(exp(res_trig_seasonal$optim.out$par)) # [38.95353592]
print(res_trig_seasonal$optim.out$value)    # 657.6629457

# Trig Seasonal (approximate diffuse)
# (with fixed period=5, full number of harmonics, seasonal variance=.05)
# Note: matching this requires setting loglikelihood_burn=0
mod_trig_seasonal_approx_diffuse <- SSModel(
  dta$unemp ~ -1 + SSMseasonal(5, Q=0.05, sea.type='trigonometric',
                               P1=diag(rep(1e6, 4))),
  H=matrix(NA))
res_trig_seasonal_approx_diffuse <- fitSSM(
  inits=c(log(var(dta$unemp))), model=mod_trig_seasonal_approx_diffuse,
  method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_trig_seasonal_approx_diffuse$optim.out$par)) # [38.95352534]
print(res_trig_seasonal_approx_diffuse$optim.out$value)    # 688.9697249

# ----------------------------------------------------------------------------

# Regression (exact diffuse)
# Note: matching this requires setting loglikelihood_burn = 0
mod_reg <- SSModel(dta$unemp ~ -1 + SSMregression(~-1+log(realgdp), data=dta),
                   H=matrix(NA))
res_reg <- fitSSM(inits=c(log(var(dta$unemp))), model=mod_reg,
                       method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_reg$optim.out$par)) # [2.215438082]
print(res_reg$optim.out$value)    # 371.7966543

# Regression (approximate diffuse)
# Note: matching this requires setting loglikelihood_burn = 0
mod_reg_approx_diffuse <- SSModel(
  dta$unemp ~ -1 + SSMregression(~-1+log(realgdp), data=dta, P1=diag(1)*1e6),
  H=matrix(NA))
res_reg_approx_diffuse <- fitSSM(
  inits=c(log(var(dta$unemp))), model=mod_reg_approx_diffuse,
  method="BFGS", control=list(REPORT=1, trace=1))

print(exp(res_reg_approx_diffuse$optim.out$par)) # [2.215447924]
print(res_reg_approx_diffuse$optim.out$value)    # 379.6233483

# ----------------------------------------------------------------------------

# Random trend + AR(1)
# Note: KFAS does not want to estimate these parameters, so just fix them
# to the MLE estimates from statsmodels and compare the loglikelihood
# mod.update([])
mod_rtrend_ar1 <- SSModel(
  dta$unemp ~ SSMtrend(2, Q=list(matrix(0), matrix(0.0609)))
    + SSMarima(ar=c(0.9592), Q=matrix(0.0097)),
  H=matrix(0))
out_rtrend_ar1 <- KFS(mod_rtrend_ar1)

print(out_rtrend_ar1$logLik)    # -31.15629379

# ----------------------------------------------------------------------------

# Local linear trend + Cycle + Seasonal + Regression + AR(1)
# (exact diffuse)
# mod.update([0.0001, 0.01, 0.06, 0.0001, 0.0001, 0.1, 2*np.pi / 10, 0.2])
mod_lltrend_cycle_seasonal_reg_ar1 <- SSModel(
  dta$unemp ~ SSMtrend(2, Q=list(matrix(0.01), matrix(0.06))) +
              SSMcycle(10, Q=matrix(0.0001)) +
              SSMseasonal(4, Q=matrix(0.0001)) +
              SSMregression(~-1+log(realgdp), data=dta) +
              SSMarima(ar=c(0.2), Q=matrix(0.1)),
H=matrix(0.0001))
out_lltrend_cycle_seasonal_reg_ar1 <- KFS(mod_lltrend_cycle_seasonal_reg_ar1)

print(out_lltrend_cycle_seasonal_reg_ar1$logLik)    # -105.8936568

# Local linear trend + Cycle + Seasonal + Regression + AR(1)
# (approximate diffuse)
# Note: matching this requires setting loglikelihood_burn = 0, and
# mod.update([0.0001, 0.01, 0.06, 0.0001, 0.0001, 0.1, 2*np.pi / 10, 0.2])
mod_lltrend_cycle_seasonal_reg_ar1_approx_diffuse <- SSModel(
  dta$unemp ~ SSMtrend(2, Q=list(matrix(0.01), matrix(0.06)), P1=diag(2)*1e6)
              + SSMcycle(10, Q=matrix(0.0001), P1=diag(2)*1e6)
              + SSMseasonal(4, Q=matrix(0.0001), P1=diag(3)*1e6)
              + SSMregression(~-1+log(realgdp), data=dta, P1=diag(1)*1e6)
              + SSMarima(ar=c(0.2), Q=matrix(0.1)),
  H=matrix(0.0001))
out_lltrend_cycle_seasonal_reg_ar1_approx_diffuse <- (
  KFS(mod_lltrend_cycle_seasonal_reg_ar1_approx_diffuse))

print(out_lltrend_cycle_seasonal_reg_ar1_approx_diffuse$logLik)  # -168.5258709

data <- read.csv('E:\\path_to_repo\\statsmodels\\datasets\\grunfeld\\grunfeld.csv')
#data <- read.csv('../../../statsmodels/datasets/grunfeld/grunfeld.csv')

data <- data[data$firm %in% c('General Motors','Chrysler','General Electric','Westinghouse','US Steel'),]
attach(data)
library('plm')
library('systemfit')
panel <- plm.data(data,c('firm','year'))
formula <- invest ~ value + capital
SUR <- systemfit(formula,method='SUR',data=panel)
f <- fitted(SUR)
ff <- c(f[,'Chrysler'],f[,'General.Electric'],f[,'General.Motors'],f[,'US.Steel'],f[,'Westinghouse'])

#save results to python module
#load functions, (windows path separators)
source("E:\\path_to_repo\\tools\\R2nparray\\R\\R2nparray.R")
#source("R2nparray.R")

#translation table for names  (could be dict in python)
translate = list(coefficients="params",
                 coefCov="cov_params",
                 residCovEst="resid_cov_est",
                 residCov="resid_cov",
                 df_residual="df_resid",
                 df_residual_sys="df_resid_sys",
                 #nCoef="k_vars",    #not sure about this
                 fitted_values="fittedvalues"
                 )

fname = "tmp_sur_0.py"
append = FALSE #TRUE

#redirect output to file
sink(file=fname, append=append)
write_header()
cat("\nsur = Bunch()\n")

cat_items(SUR, prefix="sur.", blacklist=c("eq", "control"), trans=translate)

equations = SUR[["eq"]]
for (ii in c(1:length(equations))) {
equ_name = paste("sur.equ", ii, sep="")
cat("\n\n", equ_name, sep=""); cat(" = Bunch()\n")
cat_items(equations[[ii]], prefix=paste(equ_name, ".", sep=""), trans=translate)
}

sink()

options(digits=15, scipen=999)

# Example 3.3.2 from Brockwell and Davis
ar_params = c(1, -0.25)
ma_params = c(1)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 1
ar_params = c(1, -0.25)
ma_params = c(1, 0.2)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 2
ar_params = c(1, -0.25)
ma_params = c(1, 0.2, 0.3)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 3
ar_params = c(1, -0.25)
ma_params = c(1, 0.2, 0.3, -0.35)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 4
ar_params = c(1, -0.25)
ma_params = c(1, 0.2, 0.3, -0.35, -0.1)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 5
ar_params = c(1, -0.25, 0.1)
ma_params = c(1, 0.2)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 6
ar_params = c(1, -0.25, 0.1, -0.05)
ma_params = c(1, 0.2)
print(ARMAacf(ar_params, ma_params, lag.max=9))

# Custom example 7
ar_params = c(1, -0.25, 0.1, -0.05, 0.02)
ma_params = c(1, 0.2)
print(ARMAacf(ar_params, ma_params, lag.max=9))

sanitize_name <- function(name) {
    #"[%s]" % "]|[".join(map(re.escape, list(string.punctuation.replace("_","")
    punctuation <-  '[\\!]|[\\"]|[\\#]|[\\$]|[\\%]|[\\&]|[\\\']|[\\(]|[\\)]|[\\*]|[\\+]|[\\,]|[\\-]|[\\.]|[\\/]|[\\:]|[\\;]|[\\<]|[\\=]|[\\>]|[\\?]|[\\@]|[\\[]|[\\\\]|[\\]]|[\\^]|[\\`]|[\\{]|[\\|]|[\\}]|[\\~]'
    # handle spaces,tabs,etc. and periods specially
    name <- gsub("[[:blank:]\\.]", "_", name)
    name <- gsub(punctuation, "", name)
    return(name)
}

cat_items <- function(object, prefix="", blacklist=NULL, trans=list())    {
    #print content (names) of object into python expressions for defining variables
    #
    #Parameters
    #----------
    #object : object with names attribute
    #   names(object) will be written as python assignments
    #prefix : string
    #   string that is prepended to the variable names
    #blacklist : list of strings
    #   names that are in the blacklist are ignored
    #trans : named list (dict_like)
    #   names that are in trans will be replaced by the corresponding value
    #
    #example cat_items(fitresult, blacklist=c("eq"))
    #
    #currently limited type inference, mainly numerical

    items = names(object)
    for (name in items) {
        if (is.element(name, blacklist)) next
        #cat(name); cat("\n")
        item = object[[name]]

        #fix name
        #Skipper's sanitize name
        name_ <- gsub("\\.", "_", name) # make name pythonic
        #translate name
        newname = trans[[name_]]   #translation table on sanitized names
        if (!is.null(newname)) {
            name_ = newname
        }
        name_ = paste(prefix, name_, sep="")

        if (is.numeric(item)) {
            if (!is.null(names(item))) {    #named list, class numeric ?
               mkarray2(as.matrix(item), name_);
                if (!is.null(dimnames(item))) write_dimnames(item, prefix=name_)
            }
            else if (class(item) == 'matrix') {
               mkarray2(item, name_);
                if (!is.null(dimnames(item))) write_dimnames(item, prefix=name_)
            }
            else if (class(item) == 'numeric') {   #scalar
                  cat(name_); cat(" = "); cat(item); cat("\n")
            }
        }
        else if (is.character(item)) {
            #assume string doesn't contain single quote
            cat(name_); cat(" = '"); cat(item); cat("'\n")
        }
        else {
            cat(name_); cat(" = '''"); cat(deparse(item)); cat("'''"); cat("\n")
        }

    }
} #end function

write_dimnames <- function(mat, prefix="") {
    if (prefix != "") {
        prefix = paste(prefix, "_", sep="")
    }
    dimn = list("rownames", "colnames", "thirdnames")  #up to 3 dimension ?
    for (ii in c(1:length(dimnames(mat)))) {
        cat(paste(prefix, dimn[[ii]], sep=""))
        cat (" = [");
        for (dname in dimnames(mat)[[ii]]) {
            cat("'"); cat(dname); cat("', ")
        }
        cat("]\n")
    }
}

write_header <-function() {
    cat("import numpy as np\n\n")
    cat("class Bunch(dict):\n")
    cat("    def __init__(self, **kw):\n")
    cat("        dict.__init__(self, kw)\n")
    cat("        self.__dict__  = self\n\n")
}


mkhtest <- function(ht, name, distr="f") {
    #function to write results of a statistical test of class htest to a python dict
    #
    #Parameters
    #----------
    #ht : instance of ht
    #   return of many statistical tests
    #name : string
    #   name of variable that holds results dict
    #distr : string
    #   distribution of the test statistic
    #
    cat(name); cat(" = dict(");
    cat("statistic="); cat(ht$statistic); cat(", ");
    cat("pvalue="); cat(ht$p.value); cat(", ");
    cat("parameters=("); cat(ht$parameter, sep=","); cat(",), ");
    cat("distr='"); cat(distr); cat("'");
    cat(")");
    cat("\n\n")
}

mkarray2 <- function(X, name, sanitize=FALSE) {
    indent = "    "
    if (sanitize) {
    cat(sanitize_name(name)); cat(" = np.array([\n"); cat(X, sep=", ", fill=76, labels=indent); cat(indent); cat("])") }
    else{
    cat(name); cat(" = np.array([\n"); cat(X, sep=", ", fill=76, labels=indent); cat(indent); cat("])") }
    if (is.matrix(X)) {
        i <- as.character(nrow(X))
        j <- as.character(ncol(X))
        cat(".reshape("); cat(i); cat(","); cat(j); cat(", order='F')")
    }
    cat("\n")
}

library(glmnet)
library(R2nparray)

# Run the glmnet lasso (elastic net) on all the test data sets

data = read.csv("results/lasso_data.csv", header=FALSE)

ik = 0
rslt = list()

for (n in c(100, 200, 300)) {
    for (p in c(2, 3, 5)) {

        endog = data[1:n, 1]
        exog = data[1:n, 2:(p+1)]
        exog = as.matrix(exog)

        endog = (endog - mean(endog)) / sd(endog)
        for (k in 1:p) {
            exog[,k] = exog[,k] - mean(exog[,k])
            exog[,k] = exog[,k] / sd(exog[,k])
        }

        for (alpha in c(0, 0.5, 1)) {

            fit = glmnet(exog, endog, intercept=FALSE, standardize=FALSE, alpha=alpha)
            ii = length(fit$lambda) * c(0.3, 0.5, 0.7)
            ii = round(ii)

            for (q in c(0.3, 0.5, 0.7)) {
                ii = round(q * length(fit$lambda))
                coefs = coef(fit, s=fit$lambda[ii])
                coefs = coefs[2:length(coefs)]
                rname = sprintf("rslt_%d", ik)
                ik = ik + 1
                rslt[[rname]] = c(n, p, alpha, fit$lambda[ii], coefs)
            }
        }
    }
}

R2nparray(rslt, fname="glmnet_r_results.py")

library(fpp2)
library(forecast)
library(jsonlite)

concat <- function(...) {
  return(paste(..., sep=""))
}

# get variable or NaN
get_var <- function(named, name) {
  if (name %in% names(named))
    val <- c(named[name])
  else
    val <- c(NaN)
  names(val) <- c(name)
  return(val)
}

# innov from np.random.seed(0); np.random.randn(4)
innov <- c(1.76405235, 0.40015721, 0.97873798, 2.2408932)



# fit all models and add fit results to list
obtain_model_results <- function(models, data) {
  results = list()
  for (damped in c(TRUE, FALSE)) {
    results_damped = list()
    for (model in models) {
      fitted <- tryCatch((function(){
        fit <- ets(data, model = model, damped = damped)
        pars <- list()
        # alpha, beta, gamma, phi
        for (name in c("alpha", "beta", "gamma", "phi")) {
          pars[name] <- get_var(fit$par, name)
        }
        pars$initstate <- fit$initstate
        pars$states <- fit$states
        pars$residuals <- fit$residuals
        pars$fitted <- fit$fitted
        pars$sigma2 <- fit$sigma2
        pars$loglik <- fit$loglik
        pars$forecast <- forecast(fit, 4, PI = FALSE)$mean
        pars$simulation <- simulate(fit, 4, innov = innov)
        return(pars)
      })(),
      error = function(e) list())
      results_damped[[model]] <- fitted
    }
    results[[as.character(damped)]] <- results_damped
  }
  return(results)
}

error <- c("A", "M")
trend <- c("A", "M", "N")
seasonal <- c("A", "M")

models_seasonal <- outer(error, trend, FUN = "concat") %>%
  outer(seasonal, FUN = "concat") %>% as.vector
results <- obtain_model_results(models_seasonal, austourists)
sink("fit_ets_results_seasonal.json")
cat(toJSON(results, pretty = TRUE, digits = 8))
sink()

models_nonseasonal <- outer(error, trend, FUN = "concat") %>%
  outer(c("N"), FUN = "concat") %>% as.vector
results <- obtain_model_results(models_nonseasonal, oil)
sink("fit_ets_results_nonseasonal.json")
cat(toJSON(results, pretty = TRUE, digits = 8))
sink()

library(KFAS)
library(plyr)
options(digits=10)

# should run this from the statsmodels/statsmodels directory
setwd('~/projects/statsmodels-0.9/statsmodels/')
dta <- read.csv('datasets/macrodata/macrodata.csv')

cbind.fill <- function(...){
  nm <- list(...) 
  nm <- lapply(nm, as.matrix)
  n <- max(sapply(nm, nrow)) 
  do.call(cbind, lapply(nm, function (x) 
    rbind(x, matrix(, n-nrow(x), ncol(x))))) 
}

output <- function(kf) {
  # Dimensions
  n = nrow(kf$model$y)
  p = ncol(kf$model$y)
  m = nrow(kf$model$T)
  r = nrow(kf$model$Q)

  # Construct the output dataframe
  # r = scaled_smoothed_estimator
  # N = scaled_smoothed_estimator_cov
  # m = forecasts
  # v = forecasts_error
  # F = forecasts_error_cov
  # a = predicted_state
  # P = predicted_state_cov
  # mu = filtered_forecasts
  # alphahat = smoothed_state
  # V = smoothed_state_cov
  # muhat = smoothed_forecasts
  # etahat = smoothed_state_disturbance
  # V_eta = smoothed_state_disturbance_cov
  # epshat = smoothed_measurement_disturbance
  # V_eps = smoothed_measurement_disturbance_cov
  out <- as.data.frame(with(kf, cbind.fill(
    t(r), t(r0), t(r1),
    apply(N, 3, sum), apply(N0, 3, sum), apply(N1, 3, sum), apply(N2, 3, sum),
    m, v, t(F), t(Finf),
    a, apply(P, 3, sum), apply(Pinf, 3, sum),
    att, apply(Ptt, 3, sum),
    alphahat, apply(V, 3, sum),
    muhat, apply(V_mu, 3, sum),
    etahat, apply(V_eta, 3, sum),
    epshat, t(V_eps),
    logLik
  )))
  names(out) <- c(
    paste('r', 1:m, sep='_'), paste('r0', 1:m, sep='_'), paste('r1', 1:m, sep='_'),
    'sumN', 'sumN0', 'sumN1', 'sumN2',
    paste('m', 1:p, sep='_'), paste('v', 1:p, sep='_'), paste('F', 1:p, sep='_'), paste('Finf', 1:p, sep='_'),
    paste('a', 1:m, sep='_'), 'sumP', 'sumPinf',
    paste('att', 1:m, sep='_'), 'sumPtt',
    paste('alphahat', 1:m, sep='_'), 'sumV',
    paste('muhat', 1:p, sep='_'), 'sumVmu',
    paste('etahat', 1:r, sep='_'), 'sumVeta',
    paste('epshat', 1:p, sep='_'), paste('Veps', 1:p, sep='_'),
    'llf'
  )
  return(out)
}

llf <- function(kf) {
  # Dimensions
  n = nrow(kf$model$y)
  p = ncol(kf$model$y)
  m = nrow(kf$model$T)
  r = nrow(kf$model$Q)
  d = kf$d
  F = kf$F
  Finf = kf$Finf
  v = kf$v
  
  -((n * p / 2) * log(pi * 2) +
      0.5 * sum(log(Finf[1:d])) +
      0.5 * sum(log(F[(d+1):10]) + (v^2 / t(F))[(d+1):10]))
}

# Local level
y1 <- 10.2394
sigma2_y <- 1.993
sigma2_mu <- 8.253
obs <- c(c(y1), rep(1, 9))
mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(1), T=diag(1), R=diag(1), Q=diag(1) * sigma2_mu, P1=diag(1) * 1e6), H=diag(1) * sigma2_y)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(output(kf), 'tsa/statespace/tests/results/results_exact_initial_local_level_R.csv', row.names=FALSE)
# Note: Apparent loglikelihood discrepancy
print(llf(kf))    # -22.97437545
print(kf$logLik)  # -21.13649839
print(-22.97437545 - -21.13649839) / kf$d  # -0.9189385332
print(-0.5 * log(pi * 2))  # -0.9189385332

# Local linear trend
y1 <- 10.2394
y2 <- 4.2039
y3 <- 6.123123
sigma2_y <- 1.993
sigma2_mu <- 8.253
sigma2_beta <- 2.334
obs <- c(c(y1, y2, y3), rep(1, 7))
mod <- SSModel(obs ~ -1 + SSMcustom(Z=t(as.matrix(c(1, 0))), T=as.matrix(cbind(c(1., 0), c(1, 1))), R=diag(2), Q=diag(c(sigma2_mu, sigma2_beta)), P1inf=diag(2)), H=diag(1) * sigma2_y)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(output(kf), 'tsa/statespace/tests/results/results_exact_initial_local_linear_trend_R.csv', row.names=FALSE)

# Local linear trend - missing
obs[2] <- NA
mod <- SSModel(obs ~ -1 + SSMcustom(Z=t(as.matrix(c(1, 0))), T=as.matrix(cbind(c(1., 0), c(1, 1))), R=diag(2), Q=diag(c(sigma2_mu, sigma2_beta)), P1inf=diag(2)), H=diag(1) * sigma2_y)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(output(kf), 'tsa/statespace/tests/results/results_exact_initial_local_linear_trend_missing_R.csv', row.names=FALSE)


# Common level
y11 <- 10.2394
y21 <- 8.2304
theta <- 0.1111
sigma2_1 <- 1
sigma_12 <- 0
sigma2_2 <- 1
sigma2_mu <- 3.2324
obs <- cbind(
  c(c(y11), rep(1, 9)),
  c(c(y21), rep(1, 9))
)
mod <- SSModel(obs ~ -1 + SSMcustom(
    Z=as.matrix(cbind(c(1., theta), c(0, 1))),
    T=diag(2),
    R=as.matrix(c(1, 0)),
    Q=diag(1) * sigma2_mu,
    P1inf=diag(2)),
  H=diag(2))
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(output(kf), 'tsa/statespace/tests/results/results_exact_initial_common_level_R.csv', row.names=FALSE)

# Common level - restricted
mod <- SSModel(obs ~ -1 + SSMcustom(
  Z=as.matrix(c(1, theta)),
  T=diag(1),
  R=diag(1),
  Q=diag(1) * sigma2_mu,
  P1inf=diag(1)),
  H=diag(2))
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(output(kf), 'tsa/statespace/tests/results/results_exact_initial_common_level_restricted_R.csv', row.names=FALSE)

library(vars)

data <- read.csv('/home/wesm/code/statsmodels/scikits/statsmodels/datasets/macrodata/macrodata.csv')
names <- colnames(data)
data <- log(data[c('realgdp', 'realcons', 'realinv')])
data <- sapply(data, diff)

reorder.coefs <- function(coefs) {
 n <- dim(coefs)[1]
 # put constant first...
 coefs[c(n, seq(1:(n-1))),]
}

extract.mat <- function(lst, i) {
  sapply(lst, function(x) x[,i])
}

get.coefs <- function(est) {
  reorder.coefs(extract.mat(coef(est), 1))
}

get.stderr <- function(est) {
  reorder.coefs(extract.mat(coef(est), 2))
}

reorder.phi <- function(phis) {
  # Puts things in more proper C order for comparison purposes in Python

  k <- dim(phis)[1]
  n <- dim(phis)[3]

  arr <- array(dim=c(n, k, k))

  for (i in 1:n)
    arr[i,,] <- phis[,,i]

  arr
}

causality.matrix <- function(est) {
  names <- colnames(est$y)
  K <- est$K

  # p-values
  result <- matrix(0, nrow=K, ncol=)
  for (i in 1:K) {
    ## # causes
    ## result[i,1] <- causality(est, cause=names[i])$Granger$p.value

    # caused by others
    result[i,1] <- causality(est, cause=names[-i])$Granger$p.value
  }

  colnames(result) <- c("causedby")

  result
}

get.results <- function(data, p=1) {
  sel <- VARselect(data, p) # do at most p

  est <- VAR(data, p=p)

  K <- ncol(data)

  nirfs <- 5
  orth.irf <- irf(est, n.ahead=nirfs, boot=F)$irf
  irf <- irf(est, n.ahead=nirfs, boot=F, orth=F)$irf

  crit <- t(sel$criteria)
  colnames(crit) <- c('aic', 'hqic', 'sic', 'fpe')

  resid <- resid(est)
  detomega <- det(crossprod(resid) / (est$obs - K * p - 1))

  n.ahead <- 5

  list(coefs=get.coefs(est),
       stderr=get.stderr(est),
       obs=est$obs,
       totobs=est$totobs,
       type=est$type,
       crit=as.list(crit[p,]),
       nirfs=nirfs,
       orthirf=orth.irf,
       irf=irf,
       causality=causality.matrix(est),
       detomega=detomega,
       loglike=as.numeric(logLik(est)),
       nahead=n.ahead,
       phis=Phi(est, n.ahead))
}

k <- dim(data)[2]
result <- get.results(data, p=2)

est = VAR(data, p=2)

! data are 348 monthly values (29 years) in file stl_co2
! gfortran stl-fixed.f90 stl_test_data.f90 -o stl_test
! ./stl_test < co2 > stl_test_results.csv
real(kind=8) y(348), season(348), trend(348), rw(348), work(372, 7), &
             y_short(347), season_short(347), trend_short(347), rw_short(347), &
             work_short(371, 7)
logical robust, ok, userw
read(5, *)(y(i), i = 1, 348)

print *, "scenario,idx,season,trend,rw"

n = 348
np = 12
ns = 35
nt = 19
nl = 13
no = 2
ni = 1
nsjump = 4
ntjump = 2
nljump = 2
isdeg = 1
itdeg = 1
ildeg = 1
trend = 0.0
season = 0.0
rw = 1.0
work = 0.0
call stl(y, n, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, &
         nljump, ni, no, rw, season, trend, work)
do i = 1, n
    print *, "baseline,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do

nljump = 1
trend = 0.0
season = 0.0
rw = 1.0
work = 0.0
call stl(y, n, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, &
         nljump, ni, no, rw, season, trend, work)
do i = 1, n
    print *, "nljump-1,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do

nljump = 2
ntjump = 1
trend = 0.0
season = 0.0
rw = 1.0
work = 0.0
call stl(y, n, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, &
         nljump, ni, no, rw, season, trend, work)
do i = 1, n
    print *, "ntjump-1,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do

rw = 1.0
nljump = 1
ntjump = 1
trend = 0.0
season = 0.0
rw = 1.0
work = 0.0
call stl(y, n, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, &
         nljump, ni, no, rw, season, trend, work)
do i = 1, n
    print *, "nljump-1-ntjump-1,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do


do i = 1, n-1
    y_short(i) = y(i)
end do
ntjump = 2
nljump = 2
rw_short = 1.0
trend_short = 0.0
season_short = 0.0
work_short = 0.0
call stl(y_short, n-1, np, ns, nt, nl, isdeg, itdeg, ildeg, nsjump, ntjump, &
         nljump, ni, no, rw_short, season_short, trend_short, work_short)
do i = 1, n-1
    print *, "short,", i-1, ",", season_short(i), ",", trend_short(i), ",", rw_short(i)
end do

season = 0.0
trend = 0.0
rw = 1.0
robust = .false.
call stlez(y, n, np, ns, isdeg, itdeg, robust, nconv, rw, season, trend, work)
do i = 1, n
    print *, "stlez,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do

season = 0.0
trend = 0.0
rw = 1.0
robust = .true.
call stlez(y, n, np, ns, isdeg, itdeg, robust, nconv, rw, season, trend, work)
do i = 1, n
    print *, "stlez-robust,", i-1, ",", season(i), ",", trend(i), ",", rw(i)
end do

end

library(FKF)
library(KFAS)
options(digits=10)

# Observations
df <- read.csv("clark1989.csv", header=FALSE)
lgdp = log(df$V1[5:nrow(df)])
unemp = (df$V2 / 100)[5:nrow(df)]

# True parameters
params <- c(
  0.004863, 0.00668, 0.000295, 0.001518, 0.000306, 1.43859, -0.517385,
  -0.336789, -0.163511, -0.072012
)

# Dimensions
n = 2
k = 6

# Measurement equation
H = matrix(rep(0, n*k), nrow=n)
H[1,1] = 1
H[1,2] = 1
H[2,6] = 1
obs_intercept = matrix(rep(0,n), nrow=n)
R = matrix(rep(0, n^2), nrow=n)

# Transition equation

mu = matrix(rep(0, k), nrow=k)
F = matrix(rep(0, k^2), nrow=k)
F[1,1] = 1
F[1,5] = 1
F[3,2] = 1
F[4,3] = 1
F[5,5] = 1
F[6,6] = 1

# Q = G Q_star G'
Q = matrix(rep(0, k^2), nrow=k)

# Update matrices with given parameters
H[2,2] = params[8]
H[2,3] = params[9]
H[2,4] = params[10]
F[2,2] = params[6]
F[2,3] = params[7]
R[2,2] = params[5]^2
Q[1,1] = params[1]^2
Q[2,2] = params[2]^2
Q[5,5] = params[3]^2
Q[6,6] = params[4]^2

# Initialization: Diffuse priors
initial_state = c(mu)
initial_state_cov = diag(k) * 100

initial_state_cov = (F %*% initial_state_cov) %*% (t(F))

# - FKF --------------------------------------------------------------------- #

# Filter, complete dataset
dta <- rbind(lgdp,unemp)
ans <- fkf(a0=initial_state, P0=initial_state_cov,
           dt=mu, ct=obs_intercept, Tt=F, Zt=H,
           HHt=Q, GGt=R, yt=dta)

# Filter, partially missing dataset (using KFAS)
unemp2 = unemp
n = length(unemp2)
unemp2[(n-50):n] <- NaN
dta2 <- rbind(lgdp,unemp2)
ans2 <- fkf(a0=initial_state, P0=initial_state_cov,
            dt=mu, ct=obs_intercept, Tt=F, Zt=H,
            HHt=Q, GGt=R, yt=dta2)

mod <- SSModel(t(dta2) ~ -1+SSMcustom(H, F, diag(6), Q, P1=initial_state_cov), H=R)
fit <- KFS(mod, filtering="state", smoothing="state")

# Recalculate Kalman gain
# FKF defines the Kalman gain as P Z' F^{-1}, whereas Durbin and Koopman (2012)
# use T P Z' F^{-1}, so premultiply the ans$Kt by the transition matrix
Kt = ans$Kt
for (i in 1:n) {
  Kt[,,i] = F %*% Kt[,,i]
}

# Create output columns
# 1: sum of complete dataset Kalman gain
sum_complete_Kt = colSums(Kt, dims=2)
# 2-7: filtered states from incomplete dataset
# t(ans2$att)

# Print likelihood from partial missing model
print(fit$logLik)

out <- matrix(cbind(sum_complete_Kt, t(ans2$att)))
write.csv(out, 'results_clark1989_R.csv', row.names=FALSE)

source("M:\\josef_new\\eclipse_ws\\statsmodels\\statsmodels_py34_pr\\tools\\R2nparray\\R\\R2nparray.R")
library('mgcv')
library('gamair')
d = data(mpg)

#gam_a = gam(city.mpg ~ fuel + drive + s(weight,bs="cc",k=7) + s(hp,bs="cc",k=6), data = mpg,
#            sp = c(6.46225497484073, 0.81532465890585))


#gam_a = gam(city.mpg ~ fuel + drive + s(weight,bs="bs",k=7) + s(hp,bs="bs",k=6), data = mpg)

sm_knots_w = c(1488., 1488., 1488., 1488., 1953.22222222, 2118.77777778, 2275., 2383.88888889, 2515.55555556, 2757.33333333, 3016.44444444, 3208.11111111, 4066., 4066., 4066., 4066.)
sm_knots_hp = c(48.0, 48.0, 48.0, 48.0, 68.0, 73.0, 88.0, 101.0, 116.0, 152.28571428571428, 288.0, 288.0, 288.0, 288.0)

knots_w <- data.frame(weight=sm_knots_w)
knots_h <- data.frame(hp=sm_knots_hp)
gam_a = gam(city.mpg ~ fuel + drive + s(weight,bs="bs",k=12) + s(hp,bs="bs",k=10), data = mpg, knots=c(knots_w, knots_h), family=poisson)


pls = gam_a

fname = "results_mpg_bs_poisson.py"
append = FALSE #TRUE

#redirect output to file
sink(file=fname, append=append)
write_header()
mod_name = "mpg_bs_poisson."
cat("\nmpg_bs_poisson = Bunch()\n")
cat(paste("\n", mod_name, "smooth0 = Bunch()\n", sep=""))

sm1 <- gam_a$smooth[[1]]
cat_items(sm1, prefix=paste(mod_name, "smooth0.", sep=""))
#, blacklist=c())
cat("\n")
cat(convert.numeric(pls$smooth[[1]]$S[[1]], name=paste(mod_name, "smooth0.S", sep="")))
cat("\n")
cat_items(pls, prefix=mod_name, blacklist=c("eq", "control"))
cat("\n")
pls_summ = summary(pls)
cat_items(pls_summ, prefix=mod_name, blacklist=c("eq", "control"))

params = coef(pls)
cat("\n")
cat(convert.numeric(params, name=paste(mod_name, "params", sep="")))

# stop redirecting output
sink()

# Helper functions for working with KFAS objects

cbind.fill <- function(...){
  nm <- list(...) 
  nm <- lapply(nm, as.matrix)
  n <- max(sapply(nm, nrow)) 
  do.call(cbind, lapply(nm, function (x) 
    rbind(x, matrix(, n-nrow(x), ncol(x))))) 
}

flatten <- function(m) {
  f <- t(apply(m, 3, c))
  dm <- dim(m)
  df <- dim(f)
  if(df[1] == 1 && dm[3] != 1) {
    f <- t(f)
  }
  f
}

kfas.output <- function(kf) {
  # Dimensions
  n = nrow(kf$model$y)
  p = ncol(kf$model$y)
  p2 = p^2
  m = nrow(kf$model$T)
  m2 = m^2
  mp = m * p
  r = nrow(kf$model$Q)
  r2 = r^2
  
  # Construct the output dataframe
  # r = scaled_smoothed_estimator
  # N = scaled_smoothed_estimator_cov
  # m = forecasts
  # v = forecasts_error
  # F = forecasts_error_cov
  # a = predicted_state
  # P = predicted_state_cov
  # mu = filtered_forecasts
  # alphahat = smoothed_state
  # V = smoothed_state_cov
  # muhat = smoothed_forecasts
  # etahat = smoothed_state_disturbance
  # V_eta = smoothed_state_disturbance_cov
  # epshat = smoothed_measurement_disturbance
  # V_eps = smoothed_measurement_disturbance_cov
  out <- as.data.frame(with(kf, cbind.fill(
    t(r), t(r0), t(r1),
    flatten(N), flatten(N0), flatten(N1), flatten(N2),
    m, v, t(F), t(Finf),
    flatten(K), flatten(Kinf),
    a, flatten(P), flatten(Pinf),
    att, flatten(Ptt),
    alphahat, flatten(V),
    muhat, flatten(V_mu),
    etahat, flatten(V_eta),
    epshat, t(V_eps),
    logLik
  )))
  names(out) <- c(
    paste('r', 1:m, sep='_'), paste('r0', 1:m, sep='_'), paste('r1', 1:m, sep='_'),
    paste('N', 1:m2, sep='_'), paste('N0', 1:m2, sep='_'), paste('N1', 1:m2, sep='_'), paste('N2', 1:m2, sep='_'),
    paste('m', 1:p, sep='_'), paste('v', 1:p, sep='_'), paste('F', 1:p, sep='_'), paste('Finf', 1:p, sep='_'),
    paste('K', 1:mp, sep='_'), paste('Kinf', 1:mp, sep='_'),
    paste('a', 1:m, sep='_'), paste('P', 1:m2, sep='_'), paste('Pinf', 1:m2, sep='_'),
    paste('att', 1:m, sep='_'), paste('Ptt', 1:m2, sep='_'),
    paste('alphahat', 1:m, sep='_'), paste('V', 1:m2, sep='_'),
    paste('muhat', 1:p, sep='_'), paste('Vmu', 1:p2, sep='_'),
    paste('etahat', 1:r, sep='_'), paste('Veta', 1:r2, sep='_'),
    paste('epshat', 1:p, sep='_'), paste('Veps', 1:p, sep='_'),
    'llf'
  )
  return(out)
}


kfas.llf <- function(kf) {
  # Dimensions
  n = nrow(kf$model$y)
  p = ncol(kf$model$y)
  m = nrow(kf$model$T)
  r = nrow(kf$model$Q)
  d = kf$d
  F = kf$F
  Finf = kf$Finf
  v = kf$v
  
  -((n * p / 2) * log(pi * 2) +
      0.5 * sum(log(Finf[1:d])) +
      0.5 * sum(log(F[(d+1):10]) + (v^2 / t(F))[(d+1):10]))
}

#' Print R object contents to python expression
#'
#' @param object with names attribute names(object) will be written as python assignments
#' @param prefix string string that is prepended to the variable names
#' @param blacklist list of strings names that are in the blacklist are ignored
#' @param trans named list (dict_like) names that are in trans will be replaced by the corresponding value
#' @param strict skip content that cannot be pretty-printed. Otherwise, will print as str(deparse(x))
#' @note currently limited type inference, mainly numerical
#' @export
#' @examples
#' mod = lm(rnorm(100) ~ rnorm(100))
#' cat_items(mod)
cat_items <- function(object, prefix="", strict=TRUE, trans=list(),
                      blacklist=NULL){
    out = convert_items(object, prefix, strict, trans, blacklist)
    cat(out)
}

#' Same as cat_items() except it returns a string instead of printing it
#'
#' @export
#' @examples
#' mod = lm(rnorm(100) ~ rnorm(100))
#' convert_items(mod)
convert_items <- function(object, prefix="", strict=TRUE, trans=list(),
                          blacklist=NULL){
    out = list()
    for (n in names(object)){
        if (n %in% blacklist) next
        newname = sanitize_name(n)
        if (newname %in% names(trans)){
            newname = trans[[newname]]
        }
        newname = paste(prefix, newname, sep='')
        tmp = try(convert(object[[n]], name=newname, strict=strict))
        if (class(tmp) != 'try-error'){
            out[[newname]] = tmp
        }
    }
    out = paste(out, collapse='\n')
    return(out)
}

convert <- function (x, name='default', strict=TRUE) {
       UseMethod("convert", x)
}

convert.default <- function(X, name='default', strict=TRUE){
    head = paste(name, '= ')
    mid = paste(deparse(X), collapse='\n')
    out = paste(head, "'''", mid, "'''")
    if(!strict){
        return(out)
    }
}

convert.data.frame <- function(X, name='default', strict=TRUE){
    X = as.matrix(X)
    out = convert(X, name=name)
    return(out)
}

convert.numeric <- function(X, name='default', strict=TRUE) {
    if (length(X) > 1){
        head = paste(name, '= np.array([\n')
        mid = strwrap(paste(X, collapse=', '), width=79, indent=3, exdent=4)
        mid = paste(mid, collapse='\n')
        tail = "\n    ])"
        if (is.matrix(X)) {
            i <- nrow(X)
            j <- ncol(X)
            tail = paste(tail, ".reshape(", i, ", ", j, ", order='F')\n", sep='')
        }
        out = paste(head, mid, tail, collapse='\n') 
    }else{
        out = paste(name, '=', X)
    }
    return(out)
}

convert.character <- function(X, name='default', strict=TRUE) {
    if (length(X) > 1){
        head = paste(name, '= np.array([\n')
        mid = paste("'", X, "'", sep='')
        mid = paste(mid, collapse=', ')
        tail = "\n    ])"
        out = paste(head, mid, tail)
    }else{
        out = paste(name, " = '", X, "'", sep='')
    }
    return(out)
}

sanitize_name <- function(name) {
    #"[%s]" % "]|[".join(map(re.escape, list(string.punctuation.replace("_","")
    punctuation <-  '[\\!]|[\\"]|[\\#]|[\\$]|[\\%]|[\\&]|[\\\']|[\\(]|[\\)]|[\\*]|[\\+]|[\\,]|[\\-]|[\\.]|[\\/]|[\\:]|[\\;]|[\\<]|[\\=]|[\\>]|[\\?]|[\\@]|[\\[]|[\\\\]|[\\]]|[\\^]|[\\`]|[\\{]|[\\|]|[\\}]|[\\~]'
    # handle spaces,tabs,etc. and periods specially
    name <- gsub("[[:blank:]\\.]", "_", name)
    name <- gsub(punctuation, "", name)
    return(name)
}

get_dimnames <- function(mat, prefix="", asstring=FALSE) {
    dimension_names = c('rownames', 'colnames', 3:100)
    dimn = dimnames(mat)
    if(is.null(dimn)){
        dimn = names(mat)
        if(is.null(dimn)){
            dimn = NULL
        }else{
            dimn = list(dimn)
        }
    }
    for (i in 1:length(dimn)){
        pref = paste(prefix, dimension_names[i], sep='')
        dimn[[i]] = sapply(dimn[[i]], sanitize_name)
        dimn[[i]] = paste(dimn[[i]], collapse="', '")
        dimn[[i]] = paste(pref, " = ['", dimn[[i]], "']", sep='')
    }
    dimn = paste(dimn, collapse='\n')[1]
    return(dimn)
}

# Dictionary of lambda functions
d = list()
d$df_resid = function(x) x$df.residual
d$deviance = function(x) x$deviance
d$null_deviance = function(x) x$null.deviance
d$rank = function(x) x$rank
d$aic = function(x) x$aic
d$nobs = function(x) dim(model.matrix(x))[1]
d$conf_int = function(x) as.matrix(confint(x))
d$resid = function(x) resid(x)
d$predict = function(x) predict(x)
d$fittedvalues = function(x) predict(x)
d$params = function(x) summary(x)$coefficients[,1]
d$bse = function(x) summary(x)$coefficients[,2]
d$tvalues = function(x) summary(x)$coefficients[,3]
d$pvalues = function(x) summary(x)$coefficients[,4]
d$rsquared = function(x) summary(x)$r.squared[1]
d$rsquared_adj = function(x) summary(x)$r.squared[2]
d$fvalue = function(x) summary(x)$fstatistic$statistic
d$f_pvalue = function(x) summary(x)$fstatistic$p.value
d$fstatistic = function(x) summary(x)$fstatistic

#' Applies functions to an object (skips on error)
#'
#' @param object an object on which we want to apply the lambda functions
#' @param lambdas a named list of lambda functions
#' @export
#' @examples
#' mod = lm(rnorm(100) ~ rnorm(100))
#' cat_items(apply_functions(mod))
apply_functions = function(object, lambdas=d){
    out = list()
    for (n in names(lambdas)){
        tmp = try(lambdas[[n]](object))
        if (class(tmp) != 'try-error'){
            out[[n]] = tmp
        }
    }
    return(out)
}

mkhtest <- function(ht, name, distr="f") {
    #function to write results of a statistical test of class htest to a python dict
    #
    #Parameters
    #----------
    #ht : instance of ht
    #   return of many statistical tests
    #name : string
    #   name of variable that holds results dict
    #distr : string
    #   distribution of the test statistic
    #
    cat(name); cat(" = dict(");
    cat("statistic="); cat(ht$statistic); cat(", ");
    cat("pvalue="); cat(ht$p.value); cat(", ");
    cat("parameters=("); cat(ht$parameter, sep=","); cat(",), ");
    cat("distr='"); cat(distr); cat("'");
    cat(")");
    cat("\n\n")
}

header = "
import numpy as np

from statsmodels.tools.tools import Bunch

"
write_header = function(){
    cat(header)
}

# Example
#library(plm)
#library(systemfit)
#data(Grunfeld)
#panel <- plm.data(Grunfeld, c('firm','year'))
#SUR <- systemfit(inv ~ value + capital, method='SUR',data=panel)

##translation table for names  (could be dict in python)
#translate = list(coefficients="params",
                 #coefCov="cov_params",
                 #residCovEst="resid_cov_est",
                 #residCov="resid_cov",
                 #df_residual="df_resid",
                 #df_residual_sys="df_resid_sys",
                 ##nCoef="k_vars",    #not sure about this
                 #fitted_values="fittedvalues"
                 #)

#fname = "tmp_sur_0.py"
#append = FALSE #TRUE
#sink(file=fname, append=append) #redirect output to file
#cat(header)
#cat("\nsur = Bunch()\n")

#cat_items(SUR, prefix="sur.", blacklist=c("eq", "control"), trans=translate)
#equations = SUR[["eq"]]
#for (ii in c(1:length(equations))) {
    #equ_name = paste("sur.equ", ii, sep="")
    #cat("\n\n", equ_name, sep=""); cat(" = Bunch()\n")
    #cat_items(equations[[ii]], prefix=paste(equ_name, ".", sep=""), trans=translate)
#}
#sink()

library(FKF)

# Observations
df <- read.csv("results_kalman_filter_stata.csv")
gdp = df$value
lgdp = log(gdp)
dlgdp = diff(lgdp)

# Stata parameters
params <- c(
  0.40725515, 0.18782621, -0.01514009, -0.01027267, -0.03642297, 0.11576416,
  0.02573029, -.00766572, 0.13506498, 0.08649569, 0.06942822, -0.10685783,
  0.00008
)

# Measurement equation
n = 1
H = matrix(rep(0, 12), nrow=1)
H[1,1] = 1
R = matrix(c(0), nrow=1)

# Transition equation
k = 12
mu = matrix(rep(0,k), nrow=k)
F = matrix(rep(0,k*k), nrow=k)
for (i in 1:11) {
  F[i+1,i] = 1
}

# Q = G Q_star G'
Q = matrix(rep(0,k*k), nrow=k)

# Update matrices with given parameters
F[1,1:12] = params[1:12]
Q[1,1] = params[13]

# Initialization: Unconditional mean priors
initial_state = c(solve(diag(k) - F) %*% mu)
initial_state_cov = solve(diag(k^2) - F %x% F)  %*% matrix(c(Q))
dim(initial_state_cov) <- c(k,k)

# Filter
ans <- fkf(a0=initial_state, P0=initial_state_cov,
           dt=mu, ct=matrix(0), Tt=F, Zt=H,
           HHt=Q, GGt=R, yt=rbind(dlgdp))

write.csv(t(ans$att), 'results_states_gdp_R.csv', row.names=FALSE)
unlink('results_states_cov_gdp_R.csv')
for (t in 1:length(dlgdp)) {
  write.table(t(ans$Ptt[,,t]), 'results_states_cov_gdp_R.csv', sep=",", append=TRUE, row.names=FALSE)
}

library(survival)
library(R2nparray)

ixd = list(c(20,1), c(50,1), c(50,2), c(100,5), c(1000,10))

res = list()

for (ix in ixd) {
    fname = sprintf("results/survival_data_%d_%d.csv", ix[1], ix[2])
    data = read.table(fname)

    time = data[,1]
    status = data[,2]
    entry = data[,3]
    exog = data[,4:dim(data)[2]]
    exog = as.matrix(exog)
    n = dim(exog)[1]
    p = dim(exog)[2]

    # Needs to match the kronecker statement in test_phreg.py
    strata = kronecker(seq(5), array(1, n/5))

    for (ties in c("breslow", "efron")) {

        ti = substr(ties, 1, 3)

        # Base model
        surv = Surv(time, status)
        md = coxph(surv ~ exog, ties=ties)
        tag = sprintf("%d_%d_%s", n, p, ti)
        res[[sprintf("coef_%s", tag)]] = md$coef
        res[[sprintf("se_%s", tag)]] = sqrt(diag(md$var))
        #bhaz = basehaz(md)
        bhaz = survfit(md, type="aalen")
        #bhaz = survfit(md, type="efron")
        res[[sprintf("time_%s", tag)]] = bhaz$time
        res[[sprintf("hazard_%s", tag)]] = -log(bhaz$surv)

        # With entry time
        surv = Surv(entry, time, status)
        md = coxph(surv ~ exog, ties=ties)
        tag = sprintf("%d_%d_et_%s", n, p, ti)
        res[[sprintf("coef_%s", tag)]] = md$coef
        res[[sprintf("se_%s", tag)]] = sqrt(diag(md$var))
        res[[sprintf("time_%s", tag)]] = c(0)
        res[[sprintf("hazard_%s", tag)]] = c(0)

        # With strata
        surv = Surv(time, status)
        md = coxph(surv ~ exog + strata(strata), ties=ties)
        tag = sprintf("%d_%d_st_%s", n, p, ti)
        res[[sprintf("coef_%s", tag)]] = md$coef
        res[[sprintf("se_%s", tag)]] = sqrt(diag(md$var))
        res[[sprintf("time_%s", tag)]] = c(0)
        res[[sprintf("hazard_%s", tag)]] = c(0)

        # With entry time and strata
        surv = Surv(entry, time, status)
        md = coxph(surv ~ exog + strata(strata), ties=ties)
        tag = sprintf("%d_%d_et_st_%s", n, p, ti)
        res[[sprintf("coef_%s", tag)]] = md$coef
        res[[sprintf("se_%s", tag)]] = sqrt(diag(md$var))
        res[[sprintf("time_%s", tag)]] = c(0)
        res[[sprintf("hazard_%s", tag)]] = c(0)
    }
}

R2nparray(res, fname="survival_r_results.py")

library(lme4)
library(R2nparray)

files = list.files(path="results", pattern="lme...csv")

rslt = list()

# Check the code with a sequence of data files with different
# dimensions and random effects structures.
for (file in files) {

    # Fit a model with independent random effects (irf=TRUE) or
    # dependent random effects (irf=FALSE).
    for (irf in c(FALSE, TRUE)) {

        if (irf) {
            rf = "irf"
        } else {
            rf = "drf"
        }

        # Use REML or ML estimation
        for (reml in c(FALSE, TRUE)) {

            if (reml) {
                meth = "reml"
            } else {
                meth = "ml"
            }

            data = read.csv(paste("results", file, sep="/"))

            exog_fe_ix = grep("exog_fe", names(data))
            exog_re_ix = grep("exog_re", names(data))

            # No need to check independent random effects when there is
            # only one of them.
            if (irf & (length(exog_re_ix) == 1)) {
                next
            }

            pr = length(exog_re_ix)
            fml_fe = paste(names(data)[exog_fe_ix], collapse="+")

            if (irf) {
                st = NULL
                for (ik in exog_re_ix) {
                    st[length(st) + 1] = sprintf("(0 + %s | groups)", names(data)[ik])
                }
                fml_re = paste(st, collapse="+")

                fml = sprintf("endog ~ 0 + %s + %s", fml_fe, fml_re)
            } else {
                fml_re = paste(names(data)[exog_re_ix], collapse="+")
                fml = sprintf("endog ~ 0 + %s + (0 + %s | groups)", fml_fe, fml_re)
            }

            md = lmer(as.formula(fml), data=data, REML=reml)

            ds_ix = as.integer(substr(file, 4, 6))
            rslt[[sprintf("coef_%s_%s_%d", meth, rf, ds_ix)]] = as.vector(fixef(md))
            rslt[[sprintf("vcov_%s_%s_%d", meth, rf, ds_ix)]] = as.matrix(vcov(md))
            if (irf) {
                rev = NULL
                for (k in 1:length(exog_re_ix)) {
                    rev[k] = as.numeric(VarCorr(md)[[k]])
                }
                rev = diag(rev)
                rslt[[sprintf("cov_re_%s_%s_%d", meth, rf, ds_ix)]] = rev
            } else {
                rslt[[sprintf("cov_re_%s_%s_%d", meth, rf, ds_ix)]] = array(as.numeric(VarCorr(md)$groups),
                        c(pr, pr))
            }
            rslt[[sprintf("scale_%s_%s_%d", meth, rf, ds_ix)]] = attr(VarCorr(md), "sc")^2
            rslt[[sprintf("loglike_%s_%s_%d", meth, rf, ds_ix)]] = as.numeric(logLik(md))

            # Apparently lmer does not support these things when the random effects
            # are independent.
            if (!irf) {
                reo = ranef(md, condVar=TRUE)
                re = as.matrix(reo$groups)
                condvar = attr(reo$groups, "postVar")
                rslt[[sprintf("ranef_mean_%s_%s_%d", meth, rf, ds_ix)]] = re[1,]
                rslt[[sprintf("ranef_condvar_%s_%s_%d", meth, rf, ds_ix)]] = condvar[,,1]
            }
        }
    }
}

R2nparray(rslt, fname="lme_r_results.py")

library(KFAS)
options(digits=10)

# should run this from the statsmodels/statsmodels directory
dta <- read.csv('datasets/macrodata/macrodata.csv')

obs <- diff(data.matrix(dta[c('realgdp','realcons','realinv')]))
obs[1:50,1] <- NaN
obs[20:70,2] <- NaN
obs[40:90,3] <- NaN
obs[120:130,1] <- NaN
obs[120:130,3] <- NaN

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=diag(3), R=diag(3), Q=diag(3), P1=diag(3)*1e6),  H=diag(3))
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)

# kf$logLik = -205310.9767

# r = scaled_smoothed_estimator
# N = scaled_smoothed_estimator_cov
# m = forecasts
# v = forecasts_error
# F = forecasts_error_cov
# a = predicted_state
# P = predicted_state_cov
# mu = filtered_forecasts
# alphahat = smoothed_state
# V = smoothed_state_cov
# muhat = smoothed_forecasts
# etahat = smoothed_state_disturbance
# V_eta = smoothed_state_disturbance_cov
# epshat = smoothed_measurement_disturbance
# V_eps = smoothed_measurement_disturbance_cov

out <- as.data.frame(with(kf, cbind(
  t(r)[2:203,], apply(N, 3, det)[2:203],
  m, apply(P_mu, 3, det), v, t(F),
  a[2:203,], apply(P, 3, det)[2:203],
  alphahat, apply(V, 3, det),
  muhat, apply(V_mu, 3, det),
  etahat, apply(V_eta, 3, det), epshat, t(V_eps)
)))
names(out) <- c(
  "r1", "r2", "r3", "detN",
  "m1", "m2", "m3", "detPmu",
  "v1", "v2", "v3", "F1", "F2", "F3",
  "a1", "a2", "a3", "detP",
  "alphahat1", "alphahat2", "alphahat3", "detV",
  "muhat1", "muhat2", "muhat3", "detVmu",
  "etahat1", "etahat2", "etahat3", "detVeta",
  "epshat1", "epshat2", "epshat3", "Veps1", "Veps2", "Veps3"
)
write.csv(out, 'tsa/statespace/tests/results/results_smoothing_R.csv', row.names=FALSE)

library(KFAS)
options(digits=20)

# should run this from the statsmodels/statsmodels directory
dta <- read.csv('datasets/macrodata/macrodata.csv')

obs <- diff(data.matrix(dta[c('realgdp','realcons','realinv')]))
obs[1:50,1] <- NaN
#obs[20:70,2] <- NaN
#obs[40:90,3] <- NaN
#obs[120:130,1] <- NaN
#obs[120:130,3] <- NaN

H <- diag(c(0.0000640649, 0.0000572802, 0.0017088585))
T <- t(matrix(c(-0.1119908792,  0.8441841604,  0.0238725303,
                 0.2629347724,  0.4996718412, -0.0173023305,
                -3.2192369082,  4.1536028244,  0.4514379215), 3, 3))
Q <- t(matrix(c(0.0000640649,  0.0000388496,  0.0002148769,
                0.0000388496,  0.0000572802,  0.000001555,
                0.0002148769,  0.000001555 ,  0.0017088585), 3, 3))

mod <- list(Z=diag(3), H=H, T=T, R=diag(3), Q=Q, P0=diag(3)*1e6, a0=c(0,0,0))
testmod <- list(Z=ss$Z, H=ss$H, T=ss$T, R=ss$R, Q=ss$Q, P0=ss$P0, a0=ss$a0)

ss <- list(Z=diag(3), R=H, B=T, Q=Q, V0=diag(3)*1e6, U="zero", x0="zero", tinitx=1)
marssmod <- MARSS(t(obs), model=ss)
marssout <- MARSSkfss(marssmod)

mod <- SSModel(obs ~ -1 + SSMcustom(Z=diag(3), T=T, R=diag(3), Q=Q, P1=diag(3)*1e6),  H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)

kf$logLik

# r = scaled_smoothed_estimator
# N = scaled_smoothed_estimator_cov
# m = forecasts
# v = forecasts_error
# F = forecasts_error_cov
# a = predicted_state
# P = predicted_state_cov
# mu = filtered_forecasts
# alphahat = smoothed_state
# V = smoothed_state_cov
# muhat = smoothed_forecasts
# etahat = smoothed_state_disturbance
# V_eta = smoothed_state_disturbance_cov
# epshat = smoothed_measurement_disturbance
# V_eps = smoothed_measurement_disturbance_cov

out <- as.data.frame(with(kf, cbind(
  t(r)[2:203,], apply(N, 3, det)[2:203],
  m, apply(P_mu, 3, det), v, t(F),
  a[2:203,], apply(P, 3, det)[2:203],
  alphahat, apply(V, 3, det),
  muhat, apply(V_mu, 3, det),
  etahat, apply(V_eta, 3, det), epshat, t(V_eps)
)))
names(out) <- c(
  "r1", "r2", "r3", "detN",
  "m1", "m2", "m3", "detPmu",
  "v1", "v2", "v3", "F1", "F2", "F3",
  "a1", "a2", "a3", "detP",
  "alphahat1", "alphahat2", "alphahat3", "detV",
  "muhat1", "muhat2", "muhat3", "detVmu",
  "etahat1", "etahat2", "etahat3", "detVeta",
  "epshat1", "epshat2", "epshat3", "Veps1", "Veps2", "Veps3"
)
write.csv(out, 'tsa/statespace/tests/results/results_smoothing_generalobscov_R.csv', row.names=FALSE)

library(KFAS)
library(MARSS)
options(digits=20)

# should run this from the statsmodels/statsmodels directory
dta <- read.csv('datasets/macrodata/macrodata.csv')

obs <- data.matrix(dta[c('realgdp','realcons','realinv')])
obs[,1] <- obs[,1] / sd(obs[,1], na.rm=TRUE)
obs[,2] <- obs[,2] / sd(obs[,2], na.rm=TRUE)
obs[,3] <- obs[,3] / sd(obs[,3], na.rm=TRUE)

obs[1:50,1] <- NA
obs[20:70,2] <- NA
obs[40:90,3] <- NA
obs[120:130,1] <- NA
obs[120:130,3] <- NA

Z <- diag(3)
H <- diag(3)
T <- diag(3)
R <- diag(3)
Q <- diag(3)
P0 <- diag(3) * 1e6

d <- matrix(c(1,2,3),3,1)
c <- matrix(c(4,5,6),3,1)

ss <- list(Z=Z, R=H, B=T, Q=Q, V0=P0, A=d, U=c, x0="zero", tinitx=1)
marssmod <- MARSS(t(obs), model=ss)
marssout <- MARSSkfas(marssmod, return.kfas.model=TRUE)
kf <- KFS(marssout$kfas.model, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)

# kf$logLik  # -7924.03893566

# r = scaled_smoothed_estimator
# N = scaled_smoothed_estimator_cov
# m = forecasts
# v = forecasts_error
# F = forecasts_error_cov
# a = predicted_state
# P = predicted_state_cov
# mu = filtered_forecasts
# alphahat = smoothed_state
# V = smoothed_state_cov
# muhat = smoothed_forecasts
# etahat = smoothed_state_disturbance
# V_eta = smoothed_state_disturbance_cov
# epshat = smoothed_measurement_disturbance
# V_eps = smoothed_measurement_disturbance_cov

out <- as.data.frame(with(kf, cbind(
  t(r)[2:204,1:3], apply(N[1:3,1:3,], 3, det)[2:204],
  m, apply(P_mu, 3, det), v, t(F),
  a[2:204,1:3], apply(P[1:3,1:3,], 3, det)[2:204],
  alphahat[,1:3], apply(V[1:3,1:3,], 3, det),
  muhat, apply(V_mu, 3, det),
  etahat[,1:3], apply(V_eta[1:3,1:3,], 3, det), epshat, t(V_eps)
)))
names(out) <- c(
  "r1", "r2", "r3", "detN",
  "m1", "m2", "m3", "detPmu",
  "v1", "v2", "v3", "F1", "F2", "F3",
  "a1", "a2", "a3", "detP",
  "alphahat1", "alphahat2", "alphahat3", "detV",
  "muhat1", "muhat2", "muhat3", "detVmu",
  "etahat1", "etahat2", "etahat3", "detVeta",
  "epshat1", "epshat2", "epshat3", "Veps1", "Veps2", "Veps3"
)
write.csv(out, 'tsa/statespace/tests/results/results_intercepts_R.csv', row.names=FALSE)

library(fpp)
library(forecast)
library(gdata)
options(digits=16)

# Simple exponential smoothing
oildata <- window(oil,start=1996,end=2007)
oil_fpp1 <- ses(oildata, alpha=0.2, initial="simple", h=17)
oil_fpp2 <- ses(oildata, alpha=0.6, initial="simple", h=17)
oil_fpp3 <- ses(oildata, h=17)
oil_ets <- forecast(ets(oildata), h=17)

# Holt's linear trend method
air <- window(ausair,start=1990,end=2004)
air_fpp1 <- holt(air, alpha=0.8, beta=0.2, damped=FALSE, initial="simple", h=14)
air_fpp2 <- holt(air, alpha=0.8, beta=0.2, damped=TRUE, initial="optimal", h=14)
air_ets <- forecast(ets(air, 'AAN', damped=TRUE), h=14)

# Holt-Winters seasonal method
aust <- window(austourists,start=2005)
aust_fpp1 <- hw(aust, seasonal="additive", h=5)
aust_ets1 <- forecast(ets(aust, 'AAA', damped=FALSE), h=5)
aust_ets2 <- forecast(ets(aust, 'AAA', damped=TRUE), h=5)
aust_ets3 <- forecast(ets(aust, 'ANA'), h=5)

# Save params / output
params <- data.frame(
  oil_fpp1=c(oil_fpp1$model$par['alpha'], NA, NA, NA, NA, oil_fpp1$model$par['l'], NA, NA, NA, NA, oil_fpp1$model$sigma2, oil_fpp1$model$SSE, NA, NA),
  oil_fpp2=c(oil_fpp2$model$par['alpha'], NA, NA, NA, NA, oil_fpp2$model$par['l'], NA, NA, NA, NA, oil_fpp2$model$sigma2, oil_fpp2$model$SSE, NA, NA),
  oil_fpp3=c(oil_fpp3$model$par['alpha'], NA, NA, NA, NA, oil_fpp3$model$par['l'], NA, NA, NA, NA, oil_fpp3$model$sigma2, NA, oil_fpp3$model$loglik, oil_fpp3$model$mse),
  oil_ets=c(oil_ets$model$par['alpha'], NA, NA, NA, NA, oil_ets$model$par['l'], NA, NA, NA, NA, oil_ets$model$sigma2, NA, oil_ets$model$loglik, oil_ets$model$mse),
  air_fpp1=c(air_fpp1$model$par[1:2], NA, NA, NA, air_fpp1$model$par[3:4], NA, NA, NA, air_fpp1$model$sigma2, air_fpp1$model$SSE, NA, NA),
  air_fpp2=c(air_fpp2$model$par[4], NA, air_fpp2$model$par[5], NA, air_fpp2$model$par[1:3], NA, NA, NA, air_fpp2$model$sigma2, NA, air_fpp2$model$loglik, air_fpp2$model$mse),
  air_ets=c(air_ets$model$par[1], NA, air_ets$model$par[2], NA, air_ets$model$par[3:5], NA, NA, NA, air_ets$model$sigma2, NA, air_ets$model$loglik, air_ets$model$mse),
  aust_fpp1=c(aust_fpp1$model$par[1], NA, aust_fpp1$model$par[2:3], NA, aust_fpp1$model$par[4:8], aust_fpp1$model$sigma2, NA, aust_fpp1$model$loglik, aust_fpp1$model$mse),
  aust_ets1=c(aust_ets1$model$par[1], NA, aust_ets1$model$par[2:3], NA, aust_ets1$model$par[4:8], aust_ets1$model$sigma2, NA, aust_ets1$model$loglik, aust_ets1$model$mse),
  aust_ets2=c(aust_ets2$model$par[1], NA, aust_ets2$model$par[2:9], aust_ets2$model$sigma2, NA, aust_ets2$model$loglik, aust_ets2$model$mse),
  aust_ets3=c(aust_ets3$model$par[1], NA, NA, aust_ets3$model$par[2], NA, aust_ets3$model$par[3], NA, aust_ets3$model$par[4:6], aust_ets3$model$sigma2, NA, aust_ets3$model$loglik, aust_ets3$model$mse))
row.names(params) <- c('alpha', 'beta_star', 'beta', 'gamma', 'phi', 'l0', 'b0', 's0_0', 's0_1', 's0_2', 'sigma2', 'sse', 'llf', 'mse')

# Save predict / forecast
predict <- data.frame(
  oil_fpp1_mean=c(oil_fpp1$fitted, oil_fpp1$mean),
  oil_fpp1_lower=c(rep(NA, 12), oil_fpp1$lower[,'95%']),
  oil_fpp1_upper=c(rep(NA, 12), oil_fpp1$upper[,'95%']),

  oil_fpp2_mean=c(oil_fpp2$fitted, oil_fpp2$mean),
  oil_fpp2_lower=c(rep(NA, 12), oil_fpp2$lower[,'95%']),
  oil_fpp2_upper=c(rep(NA, 12), oil_fpp2$upper[,'95%']),

  oil_fpp3_mean=c(oil_fpp3$fitted, oil_fpp3$mean),
  oil_fpp3_lower=c(rep(NA, 12), oil_fpp3$lower[,'95%']),
  oil_fpp3_upper=c(rep(NA, 12), oil_fpp3$upper[,'95%']),
  
  oil_ets_mean=c(oil_ets$fitted, oil_ets$mean),
  oil_ets_lower=c(rep(NA, 12), oil_ets$lower[,'95%']),
  oil_ets_upper=c(rep(NA, 12), oil_ets$upper[,'95%']),

  air_fpp1_mean=c(air_fpp1$fitted, air_fpp1$mean),
  air_fpp1_lower=c(rep(NA, 15), air_fpp1$lower[,'95%']),
  air_fpp1_upper=c(rep(NA, 15), air_fpp1$upper[,'95%']),

  air_fpp2_mean=c(air_fpp2$fitted, air_fpp2$mean),
  air_fpp2_lower=c(rep(NA, 15), air_fpp2$lower[,'95%']),
  air_fpp2_upper=c(rep(NA, 15), air_fpp2$upper[,'95%']),
  
  air_ets_mean=c(air_ets$fitted, air_ets$mean),
  air_ets_lower=c(rep(NA, 15), air_ets$lower[,'95%']),
  air_ets_upper=c(rep(NA, 15), air_ets$upper[,'95%']),
  
  aust_fpp1_mean=c(aust_fpp1$fitted, aust_fpp1$mean),
  aust_fpp1_lower=c(rep(NA, 24), aust_fpp1$lower[,'95%']),
  aust_fpp1_upper=c(rep(NA, 24), aust_fpp1$upper[,'95%']),
  
  aust_ets1_mean=c(aust_ets1$fitted, aust_ets1$mean),
  aust_ets1_lower=c(rep(NA, 24), aust_ets1$lower[,'95%']),
  aust_ets1_upper=c(rep(NA, 24), aust_ets1$upper[,'95%']),
  
  aust_ets2_mean=c(aust_ets2$fitted, aust_ets2$mean),
  aust_ets2_lower=c(rep(NA, 24), aust_ets2$lower[,'95%']),
  aust_ets2_upper=c(rep(NA, 24), aust_ets2$upper[,'95%']),
  
  aust_ets3_mean=c(aust_ets3$fitted, aust_ets3$mean),
  aust_ets3_lower=c(rep(NA, 24), aust_ets3$lower[,'95%']),
  aust_ets3_upper=c(rep(NA, 24), aust_ets3$upper[,'95%']))

# Save estimated states
oil_fpp1_states <- data.frame(oil_fpp1$model$states)
colnames(oil_fpp1_states) <- paste("oil_fpp1", colnames(oil_fpp1_states), sep="_")

oil_fpp2_states <- data.frame(oil_fpp2$model$states)
colnames(oil_fpp2_states) <- paste("oil_fpp2", colnames(oil_fpp2_states), sep="_")

oil_fpp3_states <- data.frame(oil_fpp3$model$states)
colnames(oil_fpp3_states) <- paste("oil_fpp3", colnames(oil_fpp3_states), sep="_")

oil_ets_states <- data.frame(oil_ets$model$states)
colnames(oil_ets_states) <- paste("oil_ets", colnames(oil_ets_states), sep="_")

air_fpp1_states <- data.frame(air_fpp1$model$states)
colnames(air_fpp1_states) <- paste("air_fpp1", colnames(air_fpp1_states), sep="_")

air_fpp2_states <- data.frame(air_fpp2$model$states)
colnames(air_fpp2_states) <- paste("air_fpp2", colnames(air_fpp2_states), sep="_")

air_ets_states <- data.frame(air_ets$model$states)
colnames(air_ets_states) <- paste("air_ets", colnames(air_ets_states), sep="_")

aust_fpp1_states <- data.frame(aust_fpp1$model$states)
colnames(aust_fpp1_states) <- paste("aust_fpp1", colnames(aust_fpp1_states), sep="_")

aust_ets1_states <- data.frame(aust_ets1$model$states)
colnames(aust_ets1_states) <- paste("aust_ets1", colnames(aust_ets1_states), sep="_")

aust_ets2_states <- data.frame(aust_ets2$model$states)
colnames(aust_ets2_states) <- paste("aust_ets2", colnames(aust_ets2_states), sep="_")

aust_ets3_states <- data.frame(aust_ets3$model$states)
colnames(aust_ets3_states) <- paste("aust_ets3", colnames(aust_ets3_states), sep="_")

states <- cbindX(
  oil_fpp1_states, oil_fpp2_states, oil_fpp3_states, oil_ets_states,
  air_fpp1_states, air_fpp2_states, air_ets_states,
  aust_fpp1_states, aust_ets1_states, aust_ets2_states, aust_ets3_states)

write.csv(params, 'exponential_smoothing_params.csv')
write.csv(predict, 'exponential_smoothing_predict.csv')
write.csv(states, 'exponential_smoothing_states.csv')

# R code to dump fair test dataset to 
# checking compatibility.
#
# Usage:
#   Rscript test_get_R_tweedie_var_weight.R > res_R_var_weight.py
cat("# This file auto-generated by test_get_R_tweedie_var_weight.R\n")
cat(sprintf("# Using: %s\n", R.Version()$version.string))
cat("import numpy as np\n")
cat("import pandas as pd\n")
cat("import os\n\n")
cat("from statsmodels.tools.tools import Bunch\n\n")
cat("path = os.path.abspath(__file__)\n")
cat("dir_path = os.path.dirname(path)\n")

require(statmod)

options(digits=20)
x <- (1.5)^(0:19)

MISSING <- "MISSING"

is.missing <- function(obj) {
  length(obj) == 1 && obj == MISSING
}

pyprint <- function(arr, prefix=NULL, suffix=NULL) {
  if (!is.null(prefix)) {
    cat(prefix)
  }
  if (is.missing(arr)) {
    cat("None\n")
  } else {
    cat("np.array([")
    cat("\n    ")
    i <- 1
    for (val in arr) {
      cat(val)
      if (i == length(arr)) {
        if (i %% 3 != 1) {
          cat("\n")
        }
      }
      else if (i %% 3 == 0) {
        cat(",\n    ")
      }
      else {
        cat(", ")
      }
      i <- 1 + i
    }
    cat("])")
    if (!is.null(dim(arr))) {
      cat(".reshape((")
      j <- 1
      for (size in dim(arr)) {
        cat(sprintf("%s", size))
        if (j < length(dim(arr))) {
          cat(", ")
        }
        j <- 1 + j
      }
      cat("), order=\"F\")")
    }
  }
  if (!is.null(suffix)) {
    cat(sprintf("%s\n", suffix))
  }
  else {
    cat("\n")
  }
}

cat("

")

out2py <- function(model, name, resid_csv = FALSE){
  cat("\nres = dict()\n")
  pyprint(model$coefficients, prefix = "res['params'] = ")
  pyprint(diag(vcov(model))^0.5, prefix = "res['bse'] = ")
  cat(sprintf("res['deviance'] = %f\n", model$deviance))
  
  ll = logLik(model)
  
  if (is.na(ll)) {
    cat("res['ll'] = np.nan\n")
  } else {
    cat(sprintf("res['ll'] = %f\n", ll))
  }
  
  cat("res['resids_colnames'] = [\n    'resid_response', 'resid_pearson', 'resid_deviance', 'resid_working']\n" )
  
  r <- cbind(residuals.glm(model, 'response'),
             residuals.glm(model, 'pearson'),
             residuals.glm(model, 'deviance'),
             residuals.glm(model, 'working'))
  
  if (is.character(resid_csv)) {
    write.csv(r, resid_csv, row.names = FALSE)
    cat(sprintf("csv_path = os.path.join(dir_path, '%s')\n", resid_csv))
    cat(sprintf("resids = np.array(pd.read_csv(csv_path))\n"))
    cat(sprintf("res['resids'] = resids\n"))
  } else {
    pyprint(r, "res['resids'] = ")
  }
  cat(sprintf("%s = Bunch(**res)\n", name))
}

control <- glm.control(epsilon = 1e-25, maxit = 100)

data = read.csv('../../../datasets/fair/fair.csv')
data$weights <- rep(1, length(data$rate_marriage))
data$weights[seq(1, length(data$rate_marriage), 5)] <- 5
data$weights[seq(1, length(data$rate_marriage), 13)] <- 3

model <- glm(affairs ~ 1 + age + yrs_married,
             data = data,
             family = tweedie(var.power = 1.55, link.power = 0),
             weights = weights,
             control = control)

out2py(model, "results_tweedie_aweights_nonrobust", "results_tweedie_aweights_nonrobust.csv")

data <- read.csv('stata_cancer_glm.csv')
data$weights <- rep(1, length(data$studytime))
data$weights[seq(1, length(data$studytime), 5)] <- 5
data$weights[seq(1, length(data$studytime), 13)] <- 3
data$drug <- as.factor(data$drug)

model <- glm(studytime ~ 1 + age + drug,
             data = data,
             family = Gamma(link = "log"),
             weights = weights,
             control = control)

out2py(model, "results_gamma_aweights_nonrobust")

data <- read.csv('../../../datasets/cpunish/cpunish.csv')
data$INCOME <- data$INCOME / 1000
data$weight <- c(1, 2, 3, 4, 5, 4, 3, 2, 1, 2, 3, 4, 5, 4, 3, 2, 1)

model <- glm(EXECUTIONS ~ INCOME + SOUTH - 1,
             data = data,
             family = gaussian(link = "log"),
             weights = weight,
             control = control)

out2py(model, "results_gaussian_aweights_nonrobust")

library("vars")

#data <- read.csv("/home/skipper/statsmodels/statsmodels-skipper/scikits/statsmodels/datasets/macrodata/macrodata.csv")
#data <- read.csv("/home/bart/statsmodels/scikits/statsmodels/datasets/macrodata/macrodata.csv")
data <- read.csv("C:\\statsmodels\\statsmodels-bartbkr\\scikits\\statsmodels\\datasets\\macrodata\\macrodata.csv")
names <- colnames(data)
data <- log(data[c('realgdp','realcons','realinv')])
data <- sapply(data, diff)
data = ts(data, start=c(1959,2), frequency=4)

var <-VAR(data, p=3, type= "const")
amat <- matrix(0,3,3)
amat[1,1] <- 1
amat[2,1] <- NA
amat[3,1] <- NA
amat[2,2] <- 1
amat[3,2] <- NA
amat[3,3] <- 1
bmat <- diag(3)
diag(bmat) <- NA
svar <- SVAR(var, estmethod = 'scoring', Bmat=bmat, Amat=amat)
plot(irf(svar, n.ahead=30, impulse = 'realgdp', runs=100))

library(itsmr)
options(digits=10)

# Test Hannan-Rissanen method on lake dataset using itsmr::hannan
# Python test is: test_hannan_rissanen::test_itsmr
res <- hannan(lake, 1, 1)
print(res$phi)
# [1] 0.69607715
print(res$theta)
# [1] 0.3787969217
print(res$sigma2)
# [1] 0.4773580109

dta <- read.table('data.dat', header=TRUE)
dta$Duration <- factor(dta$Duration)
dta$Weight <- factor(dta$Weight)
dta$logDays <- log(dta$Days + 1) # Use log days to "stabilize" variance

attach(dta)
library(car)
source('/home/skipper/statsmodels/statsmodels/tools/topy.R')

sum.lm = lm(logDays ~ Duration * Weight, contrasts=list(Duration=contr.sum, 
                                                        Weight=contr.sum))

anova.lm.sum <- anova(sum.lm)

for(name in names(anova.lm.sum)) {
    mkarray2(anova.lm.sum[[name]], name, TRUE)
        }; cat("\n")

anova.lm.interaction <- anova(lm(logDays ~ Duration + Weight), sum.lm)

for(name in names(anova.lm.interaction)) {
    mkarray2(anova.lm.interaction[[name]], name, TRUE)
        }; cat("\n")

anova.lm.variable <- anova(lm(logDays ~ Duration), lm(logDays ~ Duration + Weight))

anova.lm.variable2 <- anova(lm(logDays ~ Weight), lm(logDays ~ Duration + Weight))

anova.i <- anova(sum.lm)
anova.ii <- Anova(sum.lm, type='II')
anova.iii <- Anova(sum.lm, type='III')

nosum.lm = lm(logDays ~ Duration * Weight, contrasts=list(Duration=contr.treatment, Weight=contr.treatment))

anova.i.nosum <- anova(nosum.lm)
anova.ii.nosum <- Anova(nosum.lm, type='II')
anova.iii.nosum <- Anova(nosum.lm, type='III')

dta.dropped <- dta[4:60, ]
sum.lm.dropped <- lm(logDays ~ Duration * Weight,  dta.dropped,
                    contrasts=list(Duration=contr.sum, Weight=contr.sum))

anova.i.dropped <- anova(sum.lm.dropped)
anova.ii.dropped <- Anova(sum.lm.dropped, type='II')
anova.iii.dropped <- Anova(sum.lm.dropped, type='III')

for(name in names(anova.ii.dropped)) {
    mkarray2(anova.ii.dropped[[name]], name, TRUE)
        }; cat("\n")

for(name in names(anova.iii.dropped)) {
    mkarray2(anova.iii.dropped[[name]], name, TRUE)
        }; cat("\n")

anova.iii.dropped <- Anova(sum.lm.dropped, white="hc0", type='III')
for(name in names(anova.iii.dropped)) {
    mkarray2(anova.iii.dropped[[name]], name, TRUE)
        }; cat("\n")
anova.iii.dropped <- Anova(sum.lm.dropped, white="hc1", type='III')
for(name in names(anova.iii.dropped)) {
    mkarray2(anova.iii.dropped[[name]], name, TRUE)
        }; cat("\n")
anova.iii.dropped <- Anova(sum.lm.dropped, white="hc2", type='III')
for(name in names(anova.iii.dropped)) {
    mkarray2(anova.iii.dropped[[name]], name, TRUE)
        }; cat("\n")
anova.iii.dropped <- Anova(sum.lm.dropped, white="hc3", type='III')
for(name in names(anova.iii.dropped)) {
    mkarray2(anova.iii.dropped[[name]], name, TRUE)
        }; cat("\n")


anova.ii.dropped <- Anova(sum.lm.dropped, type='II', white="hc0")
for(name in names(anova.ii.dropped)) {
    mkarray2(anova.ii.dropped[[name]], name, TRUE)
        }; cat("\n")

anova.ii.dropped <- Anova(sum.lm.dropped, type='II', white="hc1")
for(name in names(anova.ii.dropped)) {
    mkarray2(anova.ii.dropped[[name]], name, TRUE)
        }; cat("\n")

anova.ii.dropped <- Anova(sum.lm.dropped, type='II', white="hc2")
for(name in names(anova.ii.dropped)) {
    mkarray2(anova.ii.dropped[[name]], name, TRUE)
        }; cat("\n")

anova.ii.dropped <- Anova(sum.lm.dropped, type='II', white="hc3")
for(name in names(anova.ii.dropped)) {
    mkarray2(anova.ii.dropped[[name]], name, TRUE)
        }; cat("\n")

library(glmnet)
library(survival)
library(R2nparray)

# List containing (sample size, # covariates) for each data set
ixd = list(c(50,2), c(100,5))

res = list()

for (ix in ixd) {

    fname = sprintf("results/survival_data_%d_%d.csv", ix[1], ix[2])
    data = read.table(fname)

    time = data[,1]
    status = data[,2]
    entry = data[,3]
    exog = data[,4:dim(data)[2]]
    exog = as.matrix(exog)
    n = dim(exog)[1]
    p = dim(exog)[2]

    for (k in 1:p) {
        exog[,k] = (exog[,k] - mean(exog[,k])) / sd(exog[,k])
    }

    surv = Surv(time, status)
    md = glmnet(exog, surv, family="cox", lambda=c(0, 0.1))
    #md1 = coxph(surv ~ exog, ties="breslow")
    tag = sprintf("%d_%d", n, p)
    res[[sprintf("coef_%s_0", tag)]] = as.vector(coef(md, s=0))
    res[[sprintf("coef_%s_1", tag)]] = as.vector(coef(md, s=0.1))
}

R2nparray(res, fname="survival_enet_r_results.py")

library(coin)
library(exact2x2)

tables = list()

tables[[1]] = matrix(c(23, 15, 19, 31), ncol=2, byrow=TRUE)

tables[[2]] = matrix(c(144, 33, 84, 126,
          2, 4, 14, 29,
          0, 2, 6, 25,
          0, 0, 1, 5), ncol=4, byrow=TRUE)

tables[[3]] = matrix(c(20, 10, 5,
          3, 30, 15,
          0, 5, 40),
          ncol=3, byrow=TRUE)

results = array(0, c(length(tables), 17))

for (k in 1:3) {

    table = as.table(tables[[k]])
    names(attributes(table)$dimnames) = c("x", "y")

    # Nominal homogeneity test with chi^2 reference
    rslt = mh_test(table)
    results[k, 1] = rslt@statistic@teststatistic
    results[k, 2] = rslt@statistic@df

    # Nominal homogeneity test with binomial reference
    if (prod(dim(table)) == 4) {
        rslt = mcnemar.exact(table)
        results[k, 3] = rslt$p.value
    }

    # Nominal homogeneity test with continuity correction
    if (prod(dim(table)) == 4) {
        rslt = mcnemar.test(table)
        results[k, 4] = rslt$p.value
    }

    # Linear-by-linear homogeneity test with linear weights
    scores = list(x=seq(dim(table)[1]), y=seq(dim(table)[2]))
    rslt = lbl_test(table, scores=scores)
    results[k, 5] = rslt@statistic@linearstatistic
    results[k, 6] = rslt@statistic@expectation
    results[k, 7] = rslt@statistic@covariance@variance
    results[k, 8] = rslt@statistic@teststatistic
    results[k, 9] = rslt@distribution@pvalue(rslt@statistic@teststatistic)

    # Linear-by-linear homogeneity test with quadratic column weights
    scores = list(x=seq(dim(table)[1]), y=seq(dim(table)[2])^2)
    rslt = lbl_test(table, scores=scores)
    results[k, 10] = rslt@statistic@linearstatistic
    results[k, 11] = rslt@statistic@expectation
    results[k, 12] = rslt@statistic@covariance@variance
    results[k, 13] = rslt@statistic@teststatistic
    results[k, 14] = rslt@distribution@pvalue(rslt@statistic@teststatistic)

    # Bowker symmetry test (apparently mcnemar.test performs a
    # symmetry test when dim>2 although this is not documented).
    rslt = mcnemar.test(table, correct=FALSE)
    results[k, 15] = rslt$statistic
    results[k, 16] = rslt$parameter[1]
    results[k, 17] = rslt$p.value
}

colnames(results) = c("homog_stat", "homog_df", "homog_binom_p",
            "homog_cont_p", "lbl_stat", "lbl_expval", "lbl_var",
            "lbl_chi2", "lbl_pvalue", "lbl2_stat", "lbl2_expval",
            "lbl2_var", "lbl2_chi2", "lbl2_pvalue", "bowker_stat",
            "bowker_df", "bowker_pvalue")

write.csv(results, file="contingency_table_r_results.csv", row.names=FALSE)

library(KFAS)
options(digits=10)

# should run this from the statsmodels/statsmodels directory
setwd('~/projects/statsmodels-0.9/statsmodels/')
dta <- read.csv('datasets/macrodata/macrodata.csv')
source('tsa/statespace/tests/results/kfas_helpers.R')

# We use the following two observation datasets
obs <- (diff(log(data.matrix(dta[c('realgdp', 'realcons')]))) * 400)[1:20,]
obs_missing <- obs
obs_missing[1:5,1] <- NA
obs_missing[9:12,] <- NA

# VAR(1)
Z <- diag(2)
T <- as.matrix(cbind(c(0.5, 0.2), c(0.3, 0.4)))
R <- diag(2)
Q <- diag(c(2, 3))
H <- diag(2) * 0
mod <- SSModel(obs ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1inf=diag(2)), H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(kfas.output(kf), 'tsa/statespace/tests/results/results_exact_initial_var1_R.csv', row.names=FALSE)

# VAR(1) + missing
mod <- SSModel(obs_missing ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1inf=diag(2)), H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(kfas.output(kf), 'tsa/statespace/tests/results/results_exact_initial_var1_missing_R.csv', row.names=FALSE)

# VAR(1) + mixed initialization
stationary_init <- 3.5714285714285716
mod <- SSModel(obs ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1inf=diag(c(1, 0)), P1=diag(c(0, stationary_init))), H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(kfas.output(kf), 'tsa/statespace/tests/results/results_exact_initial_var1_mixed_R.csv', row.names=FALSE)

# VAR(1) + measurement error
H <- diag(c(4, 5))
mod <- SSModel(obs ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1inf=diag(2)), H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(kfas.output(kf), 'tsa/statespace/tests/results/results_exact_initial_var1_measurement_error_R.csv', row.names=FALSE)

# DFM
Z <- matrix(c(0.5, 1, 0, 0), nrow=2)
T <- matrix(c(0.9, 1, 0.1, 0), nrow=2)
R <- matrix(c(1, 0), nrow=2)
Q <- diag(1)
H <- diag(c(1.5, 2))
mod <- SSModel(obs ~ -1 + SSMcustom(Z=Z, T=T, R=R, Q=Q, P1inf=diag(2)), H=H)
kf <- KFS(mod, c("state", "signal", "mean"), c("state", "signal", "mean", "disturbance"), simplify=FALSE)
write.csv(kfas.output(kf), 'tsa/statespace/tests/results/results_exact_initial_dfm_R.csv', row.names=FALSE)

library(glmnet)
library(R2nparray)

rslt = list()

for (dtype in c("binomial", "poisson")) {

    ik = 0

    data = read.csv(sprintf("enet_%s.csv", dtype))

    endog = data[, 1]
    exog = data[, 2:dim(data)[2]]
    exog = as.matrix(exog)

    for (k in 1:dim(exog)[2]) {
        exog[,k] = exog[,k] - mean(exog[,k])
        exog[,k] = exog[,k] / sd(exog[,k])
    }

    for (alpha in c(0, 0.5, 1)) {

        fit = glmnet(exog, endog, family=dtype, intercept=FALSE,
            standardize=FALSE, alpha=alpha)

        for (q in c(0.3, 0.5, 0.7)) {
            ii = round(q * length(fit$lambda))
            coefs = coef(fit, s=fit$lambda[ii])
            coefs = coefs[2:length(coefs)]
            rname = sprintf("rslt_%s_%d", dtype, ik)
            ik = ik + 1
            rslt[[rname]] = c(alpha, fit$lambda[ii], coefs)
        }
    }
}

R2nparray(rslt, fname="glmnet_r_results.py")

#!/usr/bin/env bash
# IMPORTANT: Run from inside the "doc" directory

# create rst directories if they do not exist
for d in $(find . -maxdepth 1 -type d)
do
    mkdir "$d/rst"
done

# use pandoc to convert html to rst
for f in $(find . -name '*.html')
do
    old=$(basename -- "$f")
    new=$"`basename "$f" .html`.rst"
    dir=$(dirname -- "$f")
    echo "$f"
    pandoc -o $dir/rst/$base$new $f 
done

@ECHO OFF

pushd %~dp0

REM Command file for Sphinx documentation

if "%SPHINXBUILD%" == "" (
	set SPHINXBUILD=sphinx-build
)
set SOURCEDIR=source
set BUILDDIR=build

set TOOLSPATH=../tools
set DATASETBUILD=dataset_rst.py
set NOTEBOOKBUILD=nbgenerate.py

if "%1" == "" goto help

%SPHINXBUILD% >NUL 2>NUL
if errorlevel 9009 (
	echo.
	echo.The 'sphinx-build' command was not found. Make sure you have Sphinx
	echo.installed, then set the SPHINXBUILD environment variable to point
	echo.to the full path of the 'sphinx-build' executable. Alternatively you
	echo.may add the Sphinx directory to PATH.
	echo.
	echo.If you don't have Sphinx installed, grab it from
	echo.http://sphinx-doc.org/
	exit /b 1
)

if "%1" == "html" (
    echo mkdir %BUILDDIR%\html\_static
    mkdir %BUILDDIR%\html\_static
	echo python %TOOLSPATH%/%NOTEBOOKBUILD% --parallel --report-errors --skip-existing
	rem Black list notebooks from doc build here
    python %TOOLSPATH%/%NOTEBOOKBUILD% --parallel --report-errors --skip-existing --execution-blacklist statespace_custom_models
    echo python %TOOLSPATH%/%DATASETBUILD%
    python %TOOLSPATH%/%DATASETBUILD%
)

echo %SPHINXBUILD% -M %1 %SOURCEDIR% %BUILDDIR% %SPHINXOPTS% %O%
%SPHINXBUILD% -M %1 %SOURCEDIR% %BUILDDIR% %SPHINXOPTS% %O%
goto end

if "%1" == "html" (
    echo xcopy /s /y source\examples\notebooks\generated\*.html %BUILDDIR%\html\examples\notebooks\generated\*.html
    xcopy /s /y source\examples\notebooks\generated\*.html %BUILDDIR%\html\examples\notebooks\generated\*.html
    if NOT EXIST %BUILDDIR%/html/examples/notebooks/generated mkdir %BUILDDIR%\html\examples\notebooks\generated
)

goto end

:help
%SPHINXBUILD% -M help %SOURCEDIR% %BUILDDIR% %SPHINXOPTS% %O%

:end
popd

echo Python 3.x setup
REM Setup compiler
set PATH=C:\Program Files (x86)\Microsoft Visual Studio 10.0\Common7\IDE;%PATH%
cd C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin
set DISTUTILS_USE_SDK=1
CALL "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\setenv" /x64 /release

REM Install packages using pip
set PATH=%PYTHON%;%PYTHON%\Scripts;%PATH%
python -m pip install -U pip
IF Defined SCIPY (
    pip install numpy scipy==%SCIPY% cython pandas nose patsy
) else (
    pip install numpy scipy cython pandas nose patsy
)

# Source to configure conda CI builds
if [ "$TRAVIS_OS_NAME" = "linux" ]; then
  CONDA_FILE="Miniconda3-latest-Linux-x86_64.sh";
fi
if [ "$TRAVIS_OS_NAME" = "osx" ]; then
  CONDA_FILE="Miniconda3-latest-MacOSX-x86_64.sh";
fi
wget https://repo.continuum.io/miniconda/"$CONDA_FILE" -O miniconda.sh -nv
chmod +x miniconda.sh
./miniconda.sh -b -p "$HOME"/miniconda
export PATH="$HOME"/miniconda/bin:$PATH
conda config --set always_yes yes
conda update --quiet conda
# Build package list to avoid empty package=versions; only needed for versioned packages
PKGS="numpy"; if [ ${NUMPY} ]; then PKGS="${PKGS}=${NUMPY}"; fi
PKGS="${PKGS} scipy"; if [ ${SCIPY} ]; then PKGS="${PKGS}=${SCIPY}"; fi
PKGS="${PKGS} patsy"; if [ ${PATSY} ]; then PKGS="${PKGS}=${PATSY}"; fi
PKGS="${PKGS} pandas"; if [ ${PANDAS} ]; then PKGS="${PKGS}=${PANDAS}"; fi
PKGS="${PKGS} Cython"; if [ ${CYTHON} ]; then PKGS="${PKGS}=${CYTHON}"; fi
if [ ${USE_MATPLOTLIB} = true ]; then PKGS="${PKGS} matplotlib"; if [ ${MATPLOTLIB} ]; then PKGS="${PKGS}=${MATPLOTLIB}"; fi; fi
if [ ${COVERAGE} = true ]; then export COVERAGE_OPTS=" --cov=statsmodels "; else export COVERAGE_OPTS=""; fi
echo conda create --yes --quiet -n statsmodels-test python=${PYTHON} ${BLAS} ${PKGS} ${OPTIONAL} ${DEPEND_ALWAYS}
conda create --yes --quiet -n statsmodels-test python=${PYTHON} ${BLAS} ${PKGS} ${OPTIONAL} ${DEPEND_ALWAYS}
source activate statsmodels-test
python -m pip install --upgrade pip

# Additional installation requirements for travis docbuilds

# Install system dependencies
echo sudo apt-get update
sudo apt-get update

echo sudo apt-get install graphviz libgfortran3 enchant pandoc -qq
sudo apt-get install graphviz libgfortran3 enchant pandoc -qq
# doctr and pdr
echo python -m pip install sphinx sphinx-immaterial jupyter nbconvert numpydoc pyyaml doctr pandas-datareader simplegeneric seaborn sphinxcontrib-spelling nbsphinx
python -m pip install sphinx sphinx-immaterial jupyter nbconvert numpydoc pyyaml doctr pandas-datareader simplegeneric seaborn sphinxcontrib-spelling nbsphinx

# Add pymc3 and theano for statespace_sarimax_pymc3.
echo conda install theano pymc3 -y
conda install theano pymc3 -y

echo Python 2.x setup
REM Setup compiler
REM The Windows 7 SDK with .Net 3.5 is buggy on Windows 8.  These paths are needed to fix these issues
set PATH=C:\Program Files (x86)\Microsoft Visual Studio 9.0\Common7\IDE;%PATH%
set INCLUDE=C:\Program Files\Microsoft SDKs\Windows\v7.0\Include;C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\include;%INCLUDE%
set LIB=C:\Program Files\Microsoft SDKs\Windows\v7.0\Lib\x64;C:\Program Files (x86)\Microsoft Visual Studio 9.0\VC\lib\amd64
set DISTUTILS_USE_SDK=1
REM This setenv is the setenv that came with SDK7, with the bugs fixed
CALL "C:\temp\setenv" /x64 /release

#!/bin/bash
cd ../..

## detect OS
if [ "$(uname)" == "Darwin" ]; then
    export OS=osx-64
else
    export OS=linux-64
fi


## declare Python and Numpy Versions
declare -a PY_VERSIONS=( "27" "33" "34" )
declare -a NPY_VERSIONS=( "18" "19" )

## Loop across Python and Numpy
for PY in "${PY_VERSIONS[@]}"
    do
    export CONDA_PY=$PY
    for NPY in "${NPY_VERSIONS[@]}"
    do
        export CONDA_NPY=$NPY
        binstar remove statsmodels/statsmodels/0.6.0_dev/${OS}/statsmodels-0.6.0_dev-np${NPY}py${PY}_0.tar.bz2 -f
        conda build ./tools/binstar
    done
done

#!/bin/bash
cd ../..

## declare Python and Numpy Versions
declare -a PY_VERSIONS=( "27" "33" "34" )
declare -a NPY_VERSIONS=( "18" "19" )

## Loop across Python and Numpy
for PY in "${PY_VERSIONS[@]}"
do
    export CONDA_PY=$PY
    for NPY in "${NPY_VERSIONS[@]}"
    do
        export CONDA_NPY=$NPY
        binstar remove statsmodels/statsmodels/0.6.0_dev/linux-64/statsmodels-0.6.0_dev-np${NPY}py${PY}_0.tar.bz2 -f
        conda build ./tools/binstar
    done
done

setlocal EnableDelayedExpansion
CALL "C:\Program Files\Microsoft SDKs\Windows\v7.0\Bin\SetEnv.cmd" /x64 /release
set DISTUTILS_USE_SDK=1
rem C:\Python27\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_msi
C:\Python32_64bit\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_wininst

call tools\build_win_bdist64-py26.bat
call tools\build_win_bdist32-py26.bat
call tools\build_win_bdist64-py27.bat
call tools\build_win_bdist32-py27.bat
call tools\build_win_bdist32-py32.bat
call tools\build_win_bdist64-py32.bat
call tools\build_win_bdist32-py34.bat
call tools\build_win_bdist64-py34.bat
call python setup.py sdist --formats=zip,gztar

setlocal EnableDelayedExpansion
CALL "C:\Program Files\Microsoft SDKs\Windows\v7.0\Bin\SetEnv.cmd" /x86 /release
set DISTUTILS_USE_SDK=1
C:\Python26_32bit\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_wininst
rem bdist_msi uses StrictVersion so can't be used for release candidates
rem C:\Python26_32bit\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_msi

@echo off
Setlocal EnableDelayedExpansion
REM Get current directory
SET CURRENT_WORKING_DIR=%~dp0
REM Python and NumPy versions
set PY_VERSION=27 33 34
set NPY_VERSION=18 19


(for %%P in (%PY_VERSION%) do (
    (for %%N in (%NPY_VERSION%) do (

        REM Trick to force a delay. Windows sometimes has issues with rapid file deletion
        call PING 1.1.1.1 -n 1 -w 5000 >NUL
        REM Clean up
        robocopy C:\Anaconda\conda-bld\work\ c:\temp\conda-work-trash * /MOVE /S
        del c:\temp\conda-work-trash\*.*? /s
        rmdir C:\Anaconda\conda-bld\work\.git /S /Q
        REM Trick to force a delay. Windows sometimes has issues with rapid file deletion
        call PING 1.1.1.1 -n 1 -w 30000 >NUL

        IF %%P==27 (
            call python2_setup.bat
        ) ELSE (
            call python3_setup.bat
        )
        set CONDA_PY=%%P
        set CONDA_NPY=%%N
        echo Python: !CONDA_PY!, NumPy: !CONDA_NPY!

        REM Remove from binstar
        binstar remove statsmodels/statsmodels/0.6.0_dev/win-64\statsmodels-0.6.0_dev-np!CONDA_NPY!py!CONDA_PY!_0.tar.bz2 --force
        cd %CURRENT_WORKING_DIR%
        cd ..\..
        conda build .\tools\binstar
        ))
)) 

setlocal EnableDelayedExpansion
CALL "C:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\SetEnv.cmd" /x64 /release
set DISTUTILS_USE_SDK=1
rem C:\Python27\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_msi
C:\Python34_64bit\python.exe C:\Users\skipper\statsmodels\statsmodels\setup.py bdist_wininst

#!/bin/bash

echo "inside $0"

RET=0

if [ "$LINT" == true ]; then
    echo "Linting all files with limited rules"
    flake8 statsmodels
    if [ $? -ne "0" ]; then
        echo "Changed files failed linting using the required set of rules."
        echo "Additions and changes must conform to Python code style rules."
        RET=1
    fi

    # Run with --isolated to ignore config files, the files included here
    # pass _all_ flake8 checks
    echo "Linting known clean files with strict rules"
    # Default flake8 rules plus the additional rules from setup.cfg
    flake8 --isolated  \
        --max-line-length 88 \
        --ignore=E121,E123,E126,E226,E24,E704,W503,W504,E741,E203 \
        examples \
        setup.py \
        statsmodels/__init__.py \
        statsmodels/api.py \
        statsmodels/base/__init__.py \
        statsmodels/base/distributed_estimation.py \
        statsmodels/base/elastic_net.py \
        statsmodels/base/tests/__init__.py \
        statsmodels/base/tests/test_data.py \
        statsmodels/base/tests/test_distributed_estimation.py \
        statsmodels/base/tests/test_optimize.py \
        statsmodels/base/tests/test_shrink_pickle.py \
        statsmodels/base/tests/test_transform.py \
        statsmodels/compat \
        statsmodels/compat/tests \
        statsmodels/conftest.py \
        statsmodels/datasets/__init__.py \
        statsmodels/datasets/anes96/__init__.py \
        statsmodels/datasets/cancer/__init__.py \
        statsmodels/datasets/ccard/__init__.py \
        statsmodels/datasets/china_smoking/__init__.py \
        statsmodels/datasets/co2/__init__.py \
        statsmodels/datasets/committee/__init__.py \
        statsmodels/datasets/copper/__init__.py \
        statsmodels/datasets/cpunish/__init__.py \
        statsmodels/datasets/danish_data \
        statsmodels/datasets/elec_equip \
        statsmodels/datasets/elnino/__init__.py \
        statsmodels/datasets/engel/__init__.py \
        statsmodels/datasets/fair/__init__.py \
        statsmodels/datasets/fertility/__init__.py \
        statsmodels/datasets/grunfeld/__init__.py \
        statsmodels/datasets/heart/__init__.py \
        statsmodels/datasets/interest_inflation/__init__.py \
        statsmodels/datasets/longley/__init__.py \
        statsmodels/datasets/macrodata/__init__.py \
        statsmodels/datasets/modechoice/__init__.py \
        statsmodels/datasets/nile/__init__.py \
        statsmodels/datasets/randhie/__init__.py \
        statsmodels/datasets/scotland/__init__.py \
        statsmodels/datasets/spector/__init__.py \
        statsmodels/datasets/stackloss/__init__.py \
        statsmodels/datasets/star98/__init__.py \
        statsmodels/datasets/statecrime/__init__.py \
        statsmodels/datasets/strikes/__init__.py \
        statsmodels/datasets/sunspots/__init__.py \
        statsmodels/datasets/tests \
        statsmodels/discrete/__init__.py \
        statsmodels/discrete/diagnostic.py \
        statsmodels/discrete/tests/__init__.py \
        statsmodels/discrete/tests/results \
        statsmodels/discrete/tests/test_constrained.py \
        statsmodels/discrete/tests/test_truncated_model.py \
        statsmodels/discrete/truncated_model.py \
        statsmodels/distributions/__init__.py \
        statsmodels/distributions/bernstein.py \
        statsmodels/distributions/empirical_distribution.py \
        statsmodels/distributions/copula/__init__.py \
        statsmodels/distributions/copula/api.py \
        statsmodels/distributions/copula/archimedean.py \
        statsmodels/distributions/copula/copulas.py \
        statsmodels/distributions/copula/depfunc_ev.py \
        statsmodels/distributions/copula/elliptical.py \
        statsmodels/distributions/copula/extreme_value.py \
        statsmodels/distributions/copula/other_copulas.py \
        statsmodels/distributions/copula/tests/test_model.py \
        statsmodels/distributions/copula/transforms.py \
        statsmodels/distributions/tests/__init__.py \
        statsmodels/distributions/tests/test_bernstein.py \
        statsmodels/distributions/tests/test_discrete.py \
        statsmodels/distributions/tests/test_ecdf.py \
        statsmodels/distributions/tests/test_tools.py \
        statsmodels/duration/__init__.py \
        statsmodels/duration/_kernel_estimates.py \
        statsmodels/duration/api.py \
        statsmodels/duration/tests/__init__.py \
        statsmodels/duration/tests/results \
        statsmodels/duration/tests/test_survfunc.py \
        statsmodels/emplike/__init__.py \
        statsmodels/emplike/api.py \
        statsmodels/emplike/tests \
        statsmodels/emplike/tests/results \
        statsmodels/examples/ex_ordered_model.py \
        statsmodels/examples/tests \
        statsmodels/examples/tsa/ex_var_reorder.py \
        statsmodels/formula \
        statsmodels/formula/tests \
        statsmodels/gam \
        statsmodels/gam/gam_cross_validation \
        statsmodels/gam/tests \
        statsmodels/gam/tests/results \
        statsmodels/genmod/__init__.py \
        statsmodels/genmod/_tweedie_compound_poisson.py \
        statsmodels/genmod/api.py \
        statsmodels/genmod/bayes_mixed_glm.py \
        statsmodels/genmod/families \
        statsmodels/genmod/families/tests \
        statsmodels/genmod/generalized_estimating_equations.py \
        statsmodels/genmod/qif.py \
        statsmodels/genmod/tests/__init__.py \
        statsmodels/genmod/tests/results \
        statsmodels/genmod/tests/test_gee.py \
        statsmodels/genmod/tests/test_qif.py \
        statsmodels/graphics/__init__.py \
        statsmodels/graphics/api.py \
        statsmodels/graphics/functional.py \
        statsmodels/graphics/tests/__init__.py \
        statsmodels/graphics/tests/test_agreement.py \
        statsmodels/graphics/tests/test_boxplots.py \
        statsmodels/graphics/tests/test_correlation.py \
        statsmodels/graphics/tests/test_functional.py \
        statsmodels/graphics/tests/test_gofplots.py \
        statsmodels/graphics/tests/test_tsaplots.py \
        statsmodels/graphics/tsaplots.py \
        statsmodels/imputation/__init__.py \
        statsmodels/imputation/tests/__init__.py \
        statsmodels/interface \
        statsmodels/iolib/__init__.py \
        statsmodels/iolib/api.py \
        statsmodels/iolib/openfile.py \
        statsmodels/iolib/smpickle.py \
        statsmodels/iolib/summary2.py \
        statsmodels/iolib/table.py \
        statsmodels/iolib/tableformatting.py \
        statsmodels/iolib/tests/__init__.py \
        statsmodels/iolib/tests/results \
        statsmodels/iolib/tests/test_pickle.py \
        statsmodels/iolib/tests/test_summary2.py \
        statsmodels/miscmodels/__init__.py \
        statsmodels/miscmodels/tests/__init__.py \
        statsmodels/miscmodels/tests/results \
        statsmodels/multivariate/__init__.py \
        statsmodels/multivariate/api.py \
        statsmodels/multivariate/factor_rotation/_analytic_rotation.py \
        statsmodels/multivariate/factor_rotation/tests/__init__.py \
        statsmodels/multivariate/pca.py \
        statsmodels/multivariate/tests/__init__.py \
        statsmodels/multivariate/tests/results \
        statsmodels/nonparametric/__init__.py \
        statsmodels/nonparametric/api.py \
        statsmodels/nonparametric/kde.py \
        statsmodels/nonparametric/kernels_asymmetric.py \
        statsmodels/nonparametric/tests/__init__.py \
        statsmodels/nonparametric/tests/results \
        statsmodels/nonparametric/tests/test_asymmetric.py \
        statsmodels/othermod \
        statsmodels/othermod/tests \
        statsmodels/othermod/tests/results \
        statsmodels/regression/__init__.py \
        statsmodels/regression/_prediction.py \
        statsmodels/regression/_tools.py \
        statsmodels/regression/dimred.py \
        statsmodels/regression/mixed_linear_model.py \
        statsmodels/regression/process_regression.py \
        statsmodels/regression/recursive_ls.py \
        statsmodels/regression/rolling.py \
        statsmodels/regression/tests/__init__.py \
        statsmodels/regression/tests/results \
        statsmodels/regression/tests/test_dimred.py \
        statsmodels/regression/tests/test_lme.py \
        statsmodels/regression/tests/test_processreg.py \
        statsmodels/regression/tests/test_quantile_regression.py \
        statsmodels/regression/tests/test_rolling.py \
        statsmodels/regression/tests/test_tools.py \
        statsmodels/robust \
        statsmodels/robust/tests \
        statsmodels/robust/tests/results \
        statsmodels/sandbox/__init__.py \
        statsmodels/sandbox/archive/__init__.py \
        statsmodels/sandbox/distributions/__init__.py \
        statsmodels/sandbox/distributions/examples/__init__.py \
        statsmodels/sandbox/distributions/tests/__init__.py \
        statsmodels/sandbox/distributions/tests/test_gof_new.py \
        statsmodels/sandbox/distributions/try_pot.py \
        statsmodels/sandbox/mcevaluate/__init__.py \
        statsmodels/sandbox/nonparametric/__init__.py \
        statsmodels/sandbox/nonparametric/tests/__init__.py \
        statsmodels/sandbox/panel/__init__.py \
        statsmodels/sandbox/panel/correlation_structures.py \
        statsmodels/sandbox/panel/tests/__init__.py \
        statsmodels/sandbox/regression/tests/__init__.py \
        statsmodels/sandbox/regression/tests/results_gmm_griliches.py \
        statsmodels/sandbox/regression/tests/results_gmm_griliches_iter.py \
        statsmodels/sandbox/regression/tests/results_gmm_poisson.py \
        statsmodels/sandbox/regression/tests/results_ivreg2_griliches.py \
        statsmodels/sandbox/stats/__init__.py \
        statsmodels/sandbox/stats/diagnostic.py \
        statsmodels/sandbox/stats/tests \
        statsmodels/sandbox/tests/__init__.py \
        statsmodels/sandbox/tools/__init__.py \
        statsmodels/src \
        statsmodels/stats/__init__.py \
        statsmodels/stats/_delta_method.py \
        statsmodels/stats/_knockoff.py \
        statsmodels/stats/_lilliefors.py \
        statsmodels/stats/_lilliefors_critical_values.py \
        statsmodels/stats/api.py \
        statsmodels/stats/base.py \
        statsmodels/stats/contingency_tables.py \
        statsmodels/stats/correlation_tools.py \
        statsmodels/stats/diagnostic.py \
        statsmodels/stats/diagnostic_gen.py \
        statsmodels/stats/dist_dependence_measures.py \
        statsmodels/stats/effect_size.py \
        statsmodels/stats/knockoff_regeffects.py \
        statsmodels/stats/libqsturng/__init__.py \
        statsmodels/stats/libqsturng/tests/__init__.py \
        statsmodels/stats/meta_analysis.py \
        statsmodels/stats/moment_helpers.py \
        statsmodels/stats/multicomp.py \
        statsmodels/stats/multivariate.py \
        statsmodels/stats/nonparametric.py \
        statsmodels/stats/oaxaca.py \
        statsmodels/stats/oneway.py \
        statsmodels/stats/rates.py \
        statsmodels/stats/regularized_covariance.py \
        statsmodels/stats/robust_compare.py \
        statsmodels/stats/stattools.py \
        statsmodels/stats/tabledist.py \
        statsmodels/stats/tests/__init__.py \
        statsmodels/stats/tests/results \
        statsmodels/stats/tests/test_anova_rm.py \
        statsmodels/stats/tests/test_base.py \
        statsmodels/stats/tests/test_correlation.py \
        statsmodels/stats/tests/test_deltacov.py \
        statsmodels/stats/tests/test_descriptivestats.py \
        statsmodels/stats/tests/test_diagnostic.py \
        statsmodels/stats/tests/test_dist_dependant_measures.py \
        statsmodels/stats/tests/test_effectsize.py \
        statsmodels/stats/tests/test_knockoff.py \
        statsmodels/stats/tests/test_lilliefors.py \
        statsmodels/stats/tests/test_meta.py \
        statsmodels/stats/tests/test_moment_helpers.py \
        statsmodels/stats/tests/test_multi.py \
        statsmodels/stats/tests/test_oaxaca.py \
        statsmodels/stats/tests/test_oneway.py \
        statsmodels/stats/tests/test_outliers_influence.py \
        statsmodels/stats/tests/test_qsturng.py \
        statsmodels/stats/tests/test_rates_poisson.py \
        statsmodels/stats/tests/test_regularized_covariance.py \
        statsmodels/stats/tests/test_robust_compare.py \
        statsmodels/stats/tests/test_sandwich.py \
        statsmodels/stats/tests/test_tabledist.py \
        statsmodels/tests \
        statsmodels/tools/__init__.py \
        statsmodels/tools/decorators.py \
        statsmodels/tools/docstring.py \
        statsmodels/tools/eval_measures.py \
        statsmodels/tools/grouputils.py \
        statsmodels/tools/linalg.py \
        statsmodels/tools/parallel.py \
        statsmodels/tools/rng_qrng.py \
        statsmodels/tools/rootfinding.py \
        statsmodels/tools/sequences.py \
        statsmodels/tools/sm_exceptions.py \
        statsmodels/tools/testing.py \
        statsmodels/tools/tests/__init__.py \
        statsmodels/tools/tests/test_data.py \
        statsmodels/tools/tests/test_decorators.py \
        statsmodels/tools/tests/test_docstring.py \
        statsmodels/tools/tests/test_eval_measures.py \
        statsmodels/tools/tests/test_linalg.py \
        statsmodels/tools/tests/test_testing.py \
        statsmodels/tools/tests/test_transform_model.py \
        statsmodels/tools/tests/test_web.py \
        statsmodels/tools/transform_model.py \
        statsmodels/tools/typing.py \
        statsmodels/tools/validation \
        statsmodels/tools/validation/tests \
        statsmodels/tools/web.py \
        statsmodels/tsa/__init__.py \
        statsmodels/tsa/_bds.py \
        statsmodels/tsa/adfvalues.py \
        statsmodels/tsa/api.py \
        statsmodels/tsa/ar_model.py \
        statsmodels/tsa/ardl \
        statsmodels/tsa/ardl/_pss_critical_values \
        statsmodels/tsa/ardl/tests \
        statsmodels/tsa/arima \
        statsmodels/tsa/arima/datasets \
        statsmodels/tsa/arima/datasets/brockwell_davis_2002 \
        statsmodels/tsa/arima/datasets/brockwell_davis_2002/data \
        statsmodels/tsa/arima/estimators \
        statsmodels/tsa/arima/estimators/tests \
        statsmodels/tsa/arima/tests \
        statsmodels/tsa/arima_model.py \
        statsmodels/tsa/arma_mle.py \
        statsmodels/tsa/base/__init__.py \
        statsmodels/tsa/base/prediction.py \
        statsmodels/tsa/base/tests/__init__.py \
        statsmodels/tsa/base/tests/test_datetools.py \
        statsmodels/tsa/base/tests/test_prediction.py \
        statsmodels/tsa/deterministic.py \
        statsmodels/tsa/exponential_smoothing \
        statsmodels/tsa/filters/__init__.py \
        statsmodels/tsa/filters/api.py \
        statsmodels/tsa/filters/bk_filter.py \
        statsmodels/tsa/filters/hp_filter.py \
        statsmodels/tsa/filters/tests \
        statsmodels/tsa/filters/tests/results \
        statsmodels/tsa/forecasting \
        statsmodels/tsa/forecasting/tests \
        statsmodels/tsa/holtwinters \
        statsmodels/tsa/holtwinters/tests \
        statsmodels/tsa/holtwinters/tests/results \
        statsmodels/tsa/innovations \
        statsmodels/tsa/innovations/tests \
        statsmodels/tsa/interp/__init__.py \
        statsmodels/tsa/interp/tests/__init__.py \
        statsmodels/tsa/regime_switching \
        statsmodels/tsa/regime_switching/tests \
        statsmodels/tsa/regime_switching/tests/results \
        statsmodels/tsa/seasonal.py \
        statsmodels/tsa/statespace \
        statsmodels/tsa/statespace/_filters \
        statsmodels/tsa/statespace/_smoothers \
        statsmodels/tsa/statespace/tests \
        statsmodels/tsa/statespace/tests/results \
        statsmodels/tsa/statespace/tests/results/frbny_nowcast \
        statsmodels/tsa/statespace/tests/results/frbny_nowcast/Nowcasting \
        statsmodels/tsa/statespace/tests/results/frbny_nowcast/Nowcasting/data \
        statsmodels/tsa/statespace/tests/results/frbny_nowcast/Nowcasting/data/US \
        statsmodels/tsa/statespace/tests/results/frbny_nowcast/Nowcasting/functions \
        statsmodels/tsa/stl \
        statsmodels/tsa/stl/tests \
        statsmodels/tsa/tests/__init__.py \
        statsmodels/tsa/tests/results \
        statsmodels/tsa/tests/test_ar.py \
        statsmodels/tsa/tests/test_bds.py \
        statsmodels/tsa/tests/test_deterministic.py \
        statsmodels/tsa/tests/test_seasonal.py \
        statsmodels/tsa/tests/test_tsa_tools.py \
        statsmodels/tsa/tests/test_x13.py \
        statsmodels/tsa/vector_ar/__init__.py \
        statsmodels/tsa/vector_ar/api.py \
        statsmodels/tsa/vector_ar/hypothesis_test_results.py \
        statsmodels/tsa/vector_ar/tests/JMulTi_results \
        statsmodels/tsa/vector_ar/tests/Matlab_results \
        statsmodels/tsa/vector_ar/tests/__init__.py \
        statsmodels/tsa/vector_ar/tests/results \
        statsmodels/tsa/x13.py \
        tools
    if [ $? -ne "0" ]; then
        echo "Previously passing files failed linting."
        RET=1
    fi

    # Tests any new python files
    if [ -f $(git rev-parse --git-dir)/shallow ]; then
        # Unshallow only when required, i.e., on CI
        echo "Repository is shallow"
        git fetch --unshallow --quiet
    fi
    git config remote.origin.fetch "+refs/heads/*:refs/remotes/origin/*"
    git fetch origin --quiet
    NEW_FILES=$(git diff origin/main --name-status -u -- "*.py" | grep ^A | cut -c 3- | paste -sd " " -)
    if [ -n "$NEW_FILES" ]; then
        echo "Linting newly added files with strict rules"
        echo "New files: $NEW_FILES"
        flake8 --isolated --max-line-length 88 --ignore=E121,E123,E126,E226,E24,E704,W503,W504,E741,E203 $(eval echo $NEW_FILES)
        if [ $? -ne "0" ]; then
            echo "New files failed linting."
            RET=1
        fi
    else
        echo "No new files to lint"
    fi
fi

exit "$RET"

#!/usr/bin/env bash

echo "Set git email and name"
git config --global user.email "bot@statsmodels.org"
git config --global user.name "Statsmodels Doc Bot"

echo "Remove devel"
rm -rf statsmodels.github.io/devel
echo "Make a new devel"
mkdir statsmodels.github.io/devel
echo "Checking for non-dev tagged build"
if [[ -n "${GIT_TAG}" ]] && [[ "${GIT_TAG}" != *dev ]]; then
  echo "Tag ${GIT_TAG} is defined"
  echo "Copy docs tag"
  echo mkdir statsmodels.github.io/"${GIT_TAG}"
  mkdir statsmodels.github.io/"${GIT_TAG}"
  echo cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/"${GIT_TAG}"
  cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/"${GIT_TAG}"
  pushd statsmodels.github.io || exit
  echo git add -A "${GIT_TAG}"/.
  git add -A "${GIT_TAG}"/.
  popd || exit
  # Also copy to stable
  rm -rf statsmodels.github.io/stable
  echo mkdir statsmodels.github.io/stable
  mkdir statsmodels.github.io/stable
  echo cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/stable
  cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/stable
  pushd statsmodels.github.io || exit
  echo git add -A stable/.
  git add -A stable/.
  popd || exit
else
  echo "Tag is ${GIT_TAG}. Not updating fixed documents"
fi
echo "Copy docs to devel"
echo cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/devel
cp -R "${PWD}"/docs/build/html/* statsmodels.github.io/devel
echo "Add devel"
pushd statsmodels.github.io || exit
echo git add -A devel/\*
git add -A devel/\*
echo "Change remote"
# TODO: Enable
# git remote set-url origin https://USERNAME:"${GH_PAGES_TOKEN}"@github.com/statsmodels/statsmodels.github.io.git
echo "Github Actions doc build after commit ${GITHUB_SHA::8}"
git commit -a -m "Github Actions doc build after commit ${GITHUB_SHA::8}"
echo "Push"
# TODO: Enable
# git push -f
popd || exit

# Source to configure pip CI builds
# Wheelhouse for various packages missing from pypi.
EXTRA_WHEELS="https://5cf40426d9f06eb7461d-6fe47d9331aba7cd62fc36c7196769e4.ssl.cf2.rackcdn.com"
# Wheelhouse for daily builds of some packages.
PRE_WHEELS="https://7933911d6844c6c53a7d-47bd50c35cd79bd838daf386af554a83.ssl.cf2.rackcdn.com"
EXTRA_PIP_FLAGS="--find-links=$EXTRA_WHEELS"
# Build package list to avoid empty package=versions; only needed for versioned packages
PKGS="${PKGS} numpy"; if [ ${NUMPY} ]; then PKGS="${PKGS}==${NUMPY}"; fi
PKGS="${PKGS} scipy"; if [ ${SCIPY} ]; then PKGS="${PKGS}==${SCIPY}"; fi
PKGS="${PKGS} patsy"; if [ ${PATSY} ]; then PKGS="${PKGS}==${PATSY}"; fi
PKGS="${PKGS} pandas"; if [ ${PANDAS} ]; then PKGS="${PKGS}==${PANDAS}"; fi
PKGS="${PKGS} Cython"; if [ ${CYTHON} ]; then PKGS="${PKGS}==${CYTHON}"; fi
if [ ${USE_MATPLOTLIB} = true ]; then
    PKGS="${PKGS} matplotlib"
    if [ ${MATPLOTLIB} ]; then
        PKGS="${PKGS}==${MATPLOTLIB}"
    fi
fi
if [ "${PIP_PRE}" = true ]; then
    EXTRA_PIP_FLAGS="--pre $EXTRA_PIP_FLAGS --find-links $PRE_WHEELS"
fi

# travis osx python support is limited. Use homebrew/pyenv to install python.
if [ "$TRAVIS_OS_NAME" = "osx" ]; then

  brew update && brew upgrade pyenv

  eval "$(pyenv init -)"

  pyenv install "$PYTHON"
  pyenv shell "$PYTHON"
fi

# Install in our own virtualenv
python -m pip install --upgrade pip
pip install --upgrade virtualenv
virtualenv --python=python venv
source venv/bin/activate
python --version # just to check
python -m pip install --upgrade pip
pip install ${EXTRA_PIP_FLAGS} ${PKGS} ${DEPEND_ALWAYS}

if [ "${PIP_PRE}" = true ]; then
  pip install -i https://pypi.anaconda.org/scipy-wheels-nightly/simple numpy pandas scipy --upgrade --use-deprecated=legacy-resolver
fi

REM Install required conda version and libraries
@echo on
curl -fsS -o c:\Miniconda.exe "https://repo.anaconda.com/miniconda/Miniconda3-latest-Windows-%PYTHON_ARCH%.exe"
START /WAIT C:\Miniconda.exe /S /D=C:\Py
set PATH=C:\Py;C:\Py\Scripts;C:\Py\Library\bin;%PATH%
conda config --set always_yes yes
conda update conda --quiet
IF Defined SCIPY (
    conda install numpy=%NUMPY% scipy=%SCIPY% icc_rt cython pandas pip nose patsy --quiet
) else (
    conda install numpy scipy cython pandas pip nose patsy --quiet
)

#!/usr/bin/env bash

if [[ ${USE_CONDA} == "true" ]]; then
  conda config --set always_yes true
  conda update --all --quiet
  conda create -n statsmodels-test python=${PYTHON_VERSION} -y
  conda init
  echo ${PATH}
  source activate statsmodels-test
  echo ${PATH}
  which python
  CMD="conda install -c conda-forge numpy"
else
  CMD="python -m pip install numpy"
fi

echo "Python location: $(where python)"
python -m pip install --upgrade pip setuptools wheel build
python -m pip install -r requirements-dev.txt

if [[ ${USE_CONDA} != "true" ]]; then
  python -m pip uninstall numpy scipy pandas cython -y
fi

if [[ -n ${NUMPY} ]]; then CMD="$CMD==${NUMPY}"; fi;
CMD="$CMD scipy"
if [[ -n ${SCIPY} ]]; then CMD="$CMD==${SCIPY}"; fi;
CMD="$CMD pandas"
if [[ -n ${PANDAS} ]]; then CMD="$CMD==${PANDAS}"; fi;
CMD="$CMD cython"
if [[ -n ${CYTHON} ]]; then CMD="$CMD==${CYTHON}"; fi;

if [[ ${USE_MATPLOTLIB} == true ]]; then
  CMD="$CMD matplotlib"
  if [[ -n ${MATPLOTLIB} ]]; then
    CMD="$CMD==${MATPLOTLIB}";
  fi
else
  # Uninstall if not needed
  python -m pip uninstall matplotlib -y || true
fi

CMD="${CMD} patsy ${BLAS}"
echo $CMD
eval $CMD

if [[ ${USE_CVXOPT} = true ]]; then python -m pip install cvxopt; fi

if [ "${PIP_PRE}" = true ]; then
  python -m pip install -i https://pypi.anaconda.org/scientific-python-nightly-wheels/simple numpy pandas scipy --upgrade --use-deprecated=legacy-resolver
  if [[ ${USE_MATPLOTLIB} == true ]]; then
    python -m pip install -i https://pypi.anaconda.org/scientific-python-nightly-wheels/simple matplotlib --upgrade --use-deprecated=legacy-resolver
  fi
fi

# Change to doc directory
cd "$SRCDIR"/docs

# Run notebooks as tests
pytest ../statsmodels/examples/tests

set -e

# Build documentation
echo '========================================================================'
echo '=                        Building documentation                        ='
echo '========================================================================'
echo 'make html 2>&1 | tee doc_build.log'
# Multithreaded build
export O="-j auto"
make html 2>&1 | tee doc_build.log

set +e
# Info
echo '========================================================================'
echo '=                 Opportunities To Improve (Warnings)                  ='
echo '========================================================================'
grep -E '(WARNING)' doc_build.log | grep -v '(noindex|toctree)'

# Check log
echo '========================================================================'
echo '=          Broken Behavior (Errors and Warnings to be Fixed)           ='
echo '========================================================================'
grep -E '(SEVERE|ERROR|WARNING)' doc_build.log | grep -Ev '(noindex|toctree)'

# Check that docbuild succeeded. Exit 1 if not.
echo "Checking if index.html exists"
if [ -f "build/html/index.html" ]; then
  echo "docbuild succeeded.";
else
  echo "docbuild failed. Aborting doctr.";
  echo "contents of build"
  ls build
  echo "contents of build/html"
  ls build/html
  exit 1;
fi;

# Build documentation
echo '========================================================================'
echo '=                        Checking Spelling                             ='
echo '========================================================================'
echo 'make spelling > doc_spelling.log 2>&1'
make spelling > /dev/null
echo '========================================================================'
echo '=                        Spelling Mistakes                             ='
echo '========================================================================'
if [ -f "build/spelling/output.txt" ]; then
  cat build/spelling/output.txt
fi;


# Deploy with doctr
cd "$SRCDIR"
if [[ -z "$TRAVIS_TAG" ]]; then
  doctr deploy --built-docs docs/build/html/ --deploy-repo statsmodels/statsmodels.github.io devel > /dev/null;
else
  if [[ "$TRAVIS_TAG" != *"dev"* ]]; then  # do not push on dev tags
    echo doctr deploy --build-tags --built-docs docs/build/html/ --deploy-repo statsmodels/statsmodels.github.io "$TRAVIS_TAG" > /dev/null;
    doctr deploy --build-tags --built-docs docs/build/html/ --deploy-repo statsmodels/statsmodels.github.io "$TRAVIS_TAG" > /dev/null;
    if [[ "$TRAVIS_TAG" != *"rc"* ]]; then  # do not push on main on rc
      echo doctr deploy --build-tags --built-docs docs/build/html/ --deploy-repo statsmodels/statsmodels.github.io stable > /dev/null;
      doctr deploy --build-tags --built-docs docs/build/html/ --deploy-repo statsmodels/statsmodels.github.io stable > /dev/null;
    fi;
  fi;
fi;

# Script to text examples and build docs on travis
echo '========================================================================'
echo '=                        Checking Doc Strings                          ='
echo '========================================================================'

cd "$SRCDIR"
python -m pip install numpydoc --upgrade
python "$SRCDIR"/tools/validate_docstrings.py --errors=GL03,GL04,GL05,GL06,GL07,GL08,GL09,SS01,SS04,SS05,SS06,PR01,PR02,PR03,PR04,PR05,PR06,PR07,PR08,PR10,EX04,RT01,RT02,RT03,RT04,RT05,SA05,EX04 || true

@echo on

@IF not Defined PYTEST_DIRECTIVES GOTO :RUN_FROM_INSTALL

@echo Running test from %CD%
@echo pytest -n auto -r s statsmodels --dist loadscope --skip-examples %PYTEST_DIRECTIVES%
pytest -n auto -r s statsmodels --dist loadscope --skip-examples %PYTEST_DIRECTIVES%

@GOTO :End

:RUN_FROM_INSTALL

mkdir test-run
cd test-run
@echo PYTEST_DIRECTIVES is not defined, testing using install
@echo Running test from %CD%
@echo python -c "import statsmodels;statsmodels.test(['-r s', '-n 2', '--skip-examples'], exit=True)"
python -c "import statsmodels;statsmodels.test(['-r s', '-n 2', '--skip-examples'], exit=True)"

:End

---
name: Bug report
about: Create a report to help us improve
title: ''
labels: ''
assignees: ''

---

#### Describe the bug

[A clear and concise description of what the bug is. This should explain **why** the current behaviour is a problem and why the expected output is a better solution.]

#### Code Sample, a copy-pastable example if possible


```python
# Your code here that produces the bug
# This example should be self-contained, and so not rely on external data.
# It should run in a fresh ipython session, and so include all relevant imports.
```
<details>

**Note**: As you can see, there are many issues on our GitHub tracker, so it is very possible that your issue has been posted before. Please check first before submitting so that we do not have to handle and close duplicates.

**Note**: Please be sure you are using the latest released version of `statsmodels`, or a recent build of `main`. If your problem has been fixed in an unreleased version, you might be able to use `main` until a new release occurs. 

**Note**: If you are using a released version, have you verified that the bug exists in the main branch of this repository? It helps the limited resources if we know problems exist in the current main branch so that they do not need to check whether the code sample produces a bug in the next release.

</details>


If the issue has not been resolved, please file it in the issue tracker.

#### Expected Output

A clear and concise description of what you expected to happen.

#### Output of ``import statsmodels.api as sm; sm.show_versions()``

<details>

[paste the output of ``import statsmodels.api as sm; sm.show_versions()`` here below this line]

</details>

- [ ] closes #xxxx
- [ ] tests added / passed. 
- [ ] code/documentation is well formatted.  
- [ ] properly formatted commit message. See 
      [NumPy's guide](https://docs.scipy.org/doc/numpy-1.15.1/dev/gitwash/development_workflow.html#writing-the-commit-message). 

<details>


**Notes**:

* It is essential that you add a test when making code changes. Tests are not 
  needed for doc changes.
* When adding a new function, test values should usually be verified in another package (e.g., R/SAS/Stata).
* When fixing a bug, you must add a test that would produce the bug in main and
  then show that it is fixed with the new code.
* New code additions must be well formatted. Changes should pass flake8. If on Linux or OSX, you can
  verify you changes are well formatted by running 
  ```
  git diff upstream/main -u -- "*.py" | flake8 --diff --isolated
  ```
  assuming `flake8` is installed. This command is also available on Windows 
  using the Windows System for Linux once `flake8` is installed in the 
  local Linux environment. While passing this test is not required, it is good practice and it help 
  improve code quality in `statsmodels`.
* Docstring additions must render correctly, including escapes and LaTeX.

</details>

---
name: Feature request
about: Suggest an idea for this project
title: ''
labels: ''
assignees: ''

---

#### Is your feature request related to a problem? Please describe
A clear and concise description of what the problem is. Ex. I'm always frustrated when [...]

#### Describe the solution you'd like
A clear and concise description of what you want to happen.

#### Describe alternatives you have considered
A clear and concise description of any alternative solutions or features you have considered.

#### Additional context
Add any other context about the feature request here.

\name{R2nparray}
\alias{R2nparray}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{Write R data to file as Numpy Arrays
%%  ~~function to do ... ~~
}
\description{Takes a matrix, scalar, or vector in R and dumps it to a file
as a NumPy array.
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
R2nparray(..., fname, append = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{\dots}{Scalars, vectors, or matrices. Can be part of a list or not.
%%     ~~Describe \code{\dots} here~~
}
  \item{fname}{Filename to write the arrays to.
%%     ~~Describe \code{fname} here~~
}
  \item{append}{Whether or not to append to an existing file or overwrite it.
%%     ~~Describe \code{append} here~~
}
}
\details{The names of the arugments are the names of the arrays in the file.
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{Skipper Seabold
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
mdat <- matrix(c(1,2,3, 11,12,13), nrow = 2, ncol=3)
scalar <- 127.5
vec <- c(1,2,3)

R2nparray(mdat=mdat, myscalar=scalar, vec=vec, fname="./numpyarrays")

# or use a list

lst = list(mdat=mdat, myscalar=scalar, vec=vec)
R2nparray(lst, fname="./numpyarrays")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ IO }

\name{R2nparray}
\alias{R2nparray}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
%%  ~~function to do ... ~~
}
\description{
%%  ~~ A concise (1-5 lines) description of what the function does. ~~
}
\usage{
R2nparray(..., fname, append = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{\dots}{
%%     ~~Describe \code{\dots} here~~
}
  \item{fname}{
%%     ~~Describe \code{fname} here~~
}
  \item{append}{
%%     ~~Describe \code{append} here~~
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
%%  ~Describe the value returned
%%  If it is a LIST, use
%%  \item{comp1 }{Description of 'comp1'}
%%  \item{comp2 }{Description of 'comp2'}
%% ...
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
%%  ~~who you are~~
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
%% ~~objects to See Also as \code{\link{help}}, ~~~
}
\examples{
##---- Should be DIRECTLY executable !! ----
##-- ==>  Define data, use random,
##--	or do  help(data=index)  for the standard data sets.

## The function is currently defined as
function(..., fname, append=FALSE) {
    if (!is.list(...)) {
        to_write <- list(...)
    }
    else {
        to_write <- (...)
    }
    sink(file=fname, append=append)
    # assumes appended file already imports numpy
    if (file.info(fname)$size == 0) {
        cat("import numpy as np\n\n")
        }
    for (i in c(1:length(to_write))) {
        name <- names(to_write)[i]
        X <- to_write[[i]]
        name <- gsub("\\.", "_", name) # make name pythonic
        mkarray(X=X, name=name)
    }
    sink()   
  }
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
